
; runtime functions for ontic (DoorsOS / tie version)
; by		mxm-trix	mxmtrix@gmx.net
; member of	mxm projects / timax	http://mxm.ticalc.org
; last revision	2000-04-01

        include "userlib.h"
	include "doorsos.h"
	include "graphlib.h"
	include "filelib.h"

        xdef _library
        xdef _ti92plus
        xdef _ti89
; 	xdef _ti92
        xdef ontics@0000
        xdef ontics@0001
        xdef ontics@0002
        xdef ontics@0003
        xdef ontics@0004
        xdef ontics@0005
        xdef ontics@0006
        xdef ontics@0007
        xdef ontics@0008


max_Files       equ     16

; TI92(+), TI89 initialization
; This function uses a trick
; It will return a result. The caller will recognize if it is a termination
; or not.
; To understand this take a look at ontic.c
ontics@0000:
init_tixx:
        movem.l d0-d7/a0-a6,-(a7)
        jsr     graphlib::clr_scr

	clr.w	memory_pos
        lea     Title_Picture(PC),a0
        move.l  #LCD_MEM,a1
        move.w  #30*32/4-1,d0
STitle:
        move.l  (a0)+,(a1)+
        dbra    d0,STitle

        lea     FILE_STRUCTURES(PC),a0
        moveq   #max_Files-1,d0
CFStruct:
        clr.l   (a0)+
        dbra    d0,CFStruct

        move.l  15*4(a7),exit_Address   ; for the  exit (int) function
        clr.w   d0                      ; no program termination
        movem.l (a7)+,d0-d7/a0-a6
	rts

ontics@0008:
new_ONTIC_screen:
        move.l  #LCD_MEM,a0
        lea     30*32(a0),a0
        move.w  #96/4*30-1,d0
ClearScr:
        clr.l   (a0)+
        dbra    d0,ClearScr
        rts

; Function DisplayString (char *string, int x, int y)
; Shows a string and waits for a key
; Arguments     string  4(a7)
;               x       8(a7)
;               y       10(a7)
; Returns       nothing
ontics@0001:
DisplayString:
        movem.l d0-d7/a0-a6,-(a7)

        move.l  4+15*4(a7),a0
        move.w  8+15*4(a7),d0
        move.w  10+15*4(a7),d1

        move.w  #4,-(a7)
        move.l  a0,-(a7)
        move.w  d1,-(a7)
        move.w  d0,-(a7)
        jsr     doorsos::DrawStrXY
        lea     10(a7),a7
        
        movem.l (a7)+,d0-d7/a0-a6
        rts


exit_Address	dc.l	0

; Function  exit (int error)
; Exits the program
ontics@0002:
exit:
	move.l	exit_Address,0(a7)
        moveq   #1,d0                   ; program termination
        rts


	dc.b 'CALLOC'
	EVEN

; Function calloc (int items, long size)
; Allocates a memoryblock of items*size bytes
; Positions     items   4(a0)
;               size    6(a0)        
; Returns address in d0
ontics@0003:
calloc:
        movem.l d0-d7/a1-a6,-(a7)
	clr.l	d1
	clr.l	d2
        move.w  4+14*4(a7),d1
        move.l  6+14*4(a7),d2
        mulu.w  d1,d2
        ; Size in the d2 - calculate adress
	move.w	memory_pos,d0
	cmp.w	#30000,d0
	bge	OutOfMemory
	move.l	#ontic_memory,a0
	lea	0(a0,d0.w),a0
	add.w	d2,memory_pos
	btst.b	#0,d2
	beq	End_calloc
	add.w	#1,memory_pos
End_calloc:
        movem.l (a7)+,d0-d7/a1-a6
	rts
OutOfMemory:
	move.l	#0,a0				; Return NULL
        movem.l (a7)+,d0-d7/a1-a6
        rts




; Function fgets (char *buffer, int max, FILE *input)
; Reads a line or max bytes into buffer
; Arguments	buffer		4(a7)
;		max		8(a7)
;		input		10(a7)
; struct file {
;	int handle, offset;
;	};
; Returns  number of bytes red in d0
ontics@0004:
fgets:
	movem.l d1-d7/a0-a6,-(a7)
	move.l  10+14*4(a7),a0
	move.l	(a0),a1
	clr.l	d0
	move.w	4(a0),d0
	adda.l	d0,a1
	clr.l	d3			; Nr. of bytes red
	move.l	4+14*4(a7),a4		; buffer
	move.l	8+14*4(a7),d5

ScanFromFile:
	cmp.l	d5,d3			; max bytes red?
	beq	End_of_fgets

	tst.b	(a1)			; end of file?
	beq	End_of_fgets

	move.b  (a1)+,(a4)+		; copy byte
	beq	End_of_fgets		; End of textfile?
	add.w	#1,d3			; maxcounter++
	add.w   #1,4(a0)		; new offset in filestructure

	cmpi.b	#13,-1(a4)		; end of line?
	bne	ScanFromFile
	add.w   #1,4(a0)		; skip first byte of this line

End_of_fgets:
	move.b	#0,(a4)			; set end of string
	move.l	d3,d0
	movem.l (a7)+,d1-d7/a0-a6
        rts

FILE_STRUCTURES         ds.b   6*max_Files      ; max 20 files

; function  fopen (char *file, char *access)
; Opens a file and prepares the filestructure (textfile)
; Only read access is accepted!
; Arguments	file	4(a7)
;		access	8(a7)
; Returns in d0 a pointer to the structure (0 -> error)
ontics@0005:
fopen:
	movem.l	d0-d7/a1-a6,-(a7)
	movea.l	8+14*4(a7),a0
	cmp.b	#'r',(a0)
	bne	Error
	; Open this file
	move.l  4+14*4(a7),a0
	moveq	#1,d1
	jsr	filelib::search
	cmpa.l	#0,a0
	beq	Error
	move.w	$0c(a0),d0
	move.w	d0,d4
	doorsos::DEREF d0,a0
Preparestructure:
	lea	FILE_STRUCTURES(PC),a1
FindSpace:
	tst.l	(a1)
	beq	SpaceFound
	add.w	#6,a1			
	bra	FindSpace

SpaceFound:
	movea.l	a0,a2
	move.w	0(a2),d1
	move.b	1(a2,d1.w),d3
	cmp.b	#$E0,d3			; Is it a textfile?
	beq	Next_Step

Error	clr.l	(a1)
	move.l	#0,a0
	bra	Ignore	

Next_Step:
	; Offset into this file
	move.w  #4,4(a1)
	move.l	a0,0(a1)
	move.l  a1,a0
	; Prepared structure, now the function can return

Ignore:
	movem.l	(a7)+,d0-d7/a1-a6
        rts


; Function  free (void *mem)
; Frees an allocated memoryblock
; This function is reserved for future use (for better use of the BSS table?)
; Position      mem     4(a7)
; Returns nothing
ontics@0006:
free:
        rts


; void ShowError (int ErrorNr, int x, int y);
; Parameter     ErrorNr 4(a7)
;               x       6(a7)
;               y       8(a7)
ontics@0007:
ShowError:
        movem.l d0-d7/a0-a6,-(a7)
        move.w  4+15*4(a7),d0
        lea     Error_Syntax(PC),a0
        clr.w   d3
ErrFind:
        cmp.w   d0,d3
        beq     ErrFound
FindNxt:
        tst.b   (a0)+
        bne     FindNxt
        add.w   #1,d3
        bra     ErrFind
ErrFound:
        move.w  6+15*4(a7),d2
        move.w  8+15*4(a7),d3
        move.w  #4,-(a7)
        move.l  a0,-(a7)
        move.w  d3,-(a7)
        move.w  d2,-(a7)
        jsr     doorsos::DrawStrXY
        lea     10(a7),a7
        movem.l (a7)+,d0-d7/a0-a6
        rts

Title_Picture	incbin ontic.pic


; Messages for the user
Error_Syntax    dc.b "Syntax error",0
Error_IllChar   dc.b "Illegal character",0
Error_FPCon     dc.b "Floating pointer error",0
Error_IllType   dc.b "Illegal type",0
Error_Undefined dc.b "Undefined identifier",0
Error_DupSym    dc.b "Duplicated symbol",0
Error_Punct     dc.b "Wrong punctation",0
Error_IDExpect  dc.b "Identifier expected",0
Error_NoInit    dc.b "Initialization error",0
Error_Incomplet dc.b "Incomplete definition",0
Error_IllInit   dc.b "Wrong initialization",0
Error_Block     dc.b "Block",0
Error_NoPointer dc.b "Pointer",0
Error_NoFunc    dc.b "Function",0
Error_NoMember  dc.b "Not member of the structure",0
Error_LValue    dc.b "L-Value incorrect",0
Error_Deref     dc.b "Dereferencing wrong",0
Error_Mismatch  dc.b "Mismatching",0
Error_ExprExpc  dc.b "Expression expected",0
Error_WhileExpc dc.b "while expected",0
Error_Nocase    dc.b "No case found",0
Error_Dupcase   dc.b "Duplicated case",0
Error_Label     dc.b "Label error",0
Error_Preproc   dc.b "Preprocessor error",0
Error_Include   dc.b "Error in include file",0
Error_CantOpen  dc.b "Can't open file",0
Error_Define    dc.b "#define wrong",0

	BSS

; The following BSS block will save ti memory. ontic allocates a lot of
; memory blocks. A memory block will take space in the memory table and
; since the ti hasn't a lot of memory, i think this is the better solution
ontic_memory	ds.b	32000
memory_pos	dc.w	0
        END
