/*
 *	68000 C compiler
 *
 *	Copyright 1984, 1985, 1986 Matthew Brandt.
 *  all commercial rights reserved.
 *
 *	This compiler is intended as an instructive tool for personal use. Any
 *	use for profit without the written consent of the author is prohibited.
 *
 *	This compiler may be distributed freely for non-commercial use as long
 *	as this notice stays intact. Please forward any enhancements or questions
 *	to:
 *
 *		Matthew Brandt
 *		Box 920337
 *		Norcross, Ga 30092
 */

/* this compiler is used by ontic
 * c68k was adapted and low level routines by
 * mxm-trix                     mxmtrix@gmx.net
 * member of mxm projects       http://mxm.ticalc.org
 * take a look on our page to see more information
 */

#include        "doors.h"
#include        "string.h"
#include        "stdio.h"
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "onticsd.h"


int             _ti92plus, _ti89;
// int _ti92;   // generate [tie] version

FILE            *input = 0,
                *list = 0,
                *output = 0;

int             lineno = 0;
int             nextlabel = 0;
int             lastch = 0;
int             lastst = 0;
char            lastid[20] = "";
char            laststr[20] = "";
long            ival = 0;
long            rval = 0;
/* double	  rval = 0.0 */

TABLE           gsyms = {0,0},
                lsyms = {0,0};
SYM             *lasthead = NULL;
struct slit     *strtab = 0;
int             lc_static = 0;
int             lc_auto = 0;
struct snode    *bodyptr = 0;
int             global_flag = 1;
TABLE           defsyms = {0,0};
int             save_mask = 0;          /* register save mask */

char            infile[20] = "",
                listfile[20] = "",
                outfile[20] = "";
TABLE           tagtable = {0};
int             mainflag = 0;
int             total_errors = 0;
TYP             *head = 0;
TYP             *tail = 0;
char            *declid = 0;
TYP             stdconst = { bt_long, 1, 4, {0, 0}, 0, "stdconst"};
TYP             stdint = { bt_long, 0, 4, {0, 0}, 0, 0 };
TYP             stdchar = {bt_char, 0, 1, {0, 0}, 0, 0 };
TYP             stdstring = {bt_pointer, 1, 4, {0, 0}, &stdchar, 0};
TYP             stdfunc = {bt_func, 1, 0, {0, 0}, &stdint, 0};
int             errno[80] = {0};
int             numerrs = 0;
char            iline[132] = "";
char            *lptr = 0;      /* shared with preproc */
FILE            *inclfile[10];  /* shared with preproc */
int             inclline[10] = {0};   /* shared with preproc */
int             incldepth = 0;      /* shared with preproc */
char            *linstack[20] = {0};  /* stack for substitutions */
char            chstack[20] = "";    /* place to save lastch */
int             lstackptr = 0;  /* substitution stack pointer */
int             breaklab = 0;
int             contlab = 0;
int             retlab = 0;

struct amode    push[] = { {am_adec,7} },
                pop[] = { {am_ainc,7} };
int             next_data = 0,
                next_addr = 0;
int             max_data = 0,
                max_addr = 0;
struct cse      *olist = 0;         /* list of optimizable expressions */
char            ontic_Program[16] = "";




// include function definitions
#include "funcs.h"



_main()
{

    // Here is the exit () trick
    if (init_tixx ())
    {
       release_global ();       // I hope this will free the entire memory
       return;
    } // if


    new_ONTIC_screen ();
    DisplayString ("File to compile?", 10, 42);
    // Request filename (call userlib::InputStr and copy the string)
    asm (" move.w #10,%d1
           move.w #52,%d2 
           move.w #8,%d3  
           jsr    userlib__0006 
           lea    ontic_Program,%a1
           moveq  #7,%d0
          copyloop:
           move.b (%a0)+,(%a1)+
           dbra   %d0,copyloop ");

    if( openfiles(ontic_Program))
    {
                        lineno = 0;
                        initsym();
                        getch();
                        getsym();
                        compile();
                        summary();
                        release_global();
                        closefiles();
    } /* if */
}

int	options(char *s)
{	return 0;
}

int     openfiles(char *s)
{       char    *p;
        int     ofl, lfl;
        strcpy(infile,s);
        strcpy(listfile,s);
        strcpy(outfile,s);
        makename(listfile,".lis");
        makename(outfile,".s");
        if( (input = fopen(infile,"r")) == 0) {
                // printf(" cant open %s\n",infile);
                return 0;
                }
/*        ofl = creat(outfile,-1);
        if( ofl < 0 )
                {
                // printf(" cant create %s\n",outfile);
                // fclose(input);
                return 0;
                }
        if( (output = fdopen(ofl,"w")) == 0) {
                // printf(" cant open %s\n",outfile);
                // fclose(input);
                return 0;
                }
        if( (list = fopen(listfile,"w")) == 0) {
                // printf(" cant open %s\n",listfile);
                // fclose(input);
                // fclose(output);
                return 0;
                }*/
        return 1;
}

void makename(char *s, char *e)
{       while(*s != 0 && *s != '.')
                ++s;
        while(*s++ = *e++);
}

void summary()
{       
	char	MemoryArea[80];

        new_ONTIC_screen ();
        DisplayString ("Summary", 10, 42);
        sprintf (MemoryArea, "%d errors found", total_errors);
        DisplayString (MemoryArea, 10, 52);
        ReadKey ();

/*      // printf("\n -- %d errors found.",total_errors);
        // fprintf(list,"\f\n *** global scope symbol table ***\n\n");
        list_table(&gsyms,0);
        // fprintf(list,"\n *** structures and unions ***\n\n");
        list_table(&tagtable,0);*/
}

void closefiles()
{       // fclose(input);
        // fclose(output);
        // fclose(list);
}

int     imax(int i,int j)
{       return (i > j) ? i : j;
}

char    *litlate(char *s)
{       char    *p;
        p = xalloc(strlen(s) + 1);
        strcpy(p,s);
        return p;
}

TYP     *maketype(int bt, int siz)
{       TYP     *tp;
        tp = (TYP *) xalloc(sizeof(TYP));
        tp->val_flag = 0;
        tp->size = siz;
        tp->type = bt;
        tp->sname = 0;
        tp->lst.head = 0;
        return tp;
}

int     decl(TABLE *table)
{       switch (lastst) {
                case kw_char:
                        head = tail = maketype(bt_char,1);
                        getsym();
                        break;
                case kw_short:
                        head = tail = maketype(bt_short,2);
                        getsym();
                        break;
                case kw_int: case kw_long:
                        head = tail = maketype(bt_long,4);
                        getsym();
                        break;
                case kw_unsigned:
                        head = tail = maketype(bt_unsigned,4);
                        getsym();
                        if( lastst == kw_int )
                                getsym();
                        break;
                case id:                /* no type declarator */
                        head = tail = maketype(bt_long,4);
                        break;
                case kw_float:
                        head = tail = maketype(bt_float,4);
                        getsym();
                        break;
                case kw_double:
                        head = tail = maketype(bt_double,8);
                        getsym();
                        break;
                case kw_enum:
                        getsym();
                        declenum(table);
                        break;
                case kw_struct:
                        getsym();
                        declstruct(bt_struct);
                        break;
                case kw_union:
                        getsym();
                        declstruct(bt_union);
                        break;
                }
}

void decl1()
{       TYP     *temp1, *temp2, *temp3, *temp4;
        switch (lastst) {
                case id:
                        declid = litlate(lastid);
                        getsym();
                        decl2();
                        break;
                case star:
                        temp1 = maketype(bt_pointer,4);
                        temp1->btp = head;
                        head = temp1;
                        if(tail == NULL)
                                tail = head;
                        getsym();
                        decl1();
                        break;
                case openpa:
                        getsym();
                        temp1 = head;
                        temp2 = tail;
                        head = tail = NULL;
                        decl1();
                        needpunc(closepa);
                        temp3 = head;
                        temp4 = tail;
                        head = temp1;
                        tail = temp2;
                        decl2();
                        temp4->btp = head;
                        if(temp4->type == bt_pointer &&
                                temp4->val_flag != 0 && head != NULL)
                                temp4->size *= head->size;
                        head = temp3;
                        break;
                default:
                        decl2();
                        break;
                }
}

void decl2()
{       TYP     *temp1;
        switch (lastst) {
                case openbr:
                        getsym();
                        temp1 = maketype(bt_pointer,0);
                        temp1->val_flag = 1;
                        temp1->btp = head;
                        if(lastst == closebr) {
                                temp1->size = 0;
                                getsym();
                                }
                        else if(head != NULL) {
                                temp1->size = intexpr() * head->size;
                                needpunc(closebr);
                                }
                        else {
                                temp1->size = intexpr();
                                needpunc(closebr);
                                }
                        head = temp1;
                        if( tail == NULL)
                                tail = head;
                        decl2();
                        break;
                case openpa:
                        getsym();
                        temp1 = maketype(bt_func,0);
                        temp1->val_flag = 1;
                        temp1->btp = head;
                        head = temp1;
                        if( lastst == closepa) {
                                getsym();
                                if(lastst == begin)
                                        temp1->type = bt_ifunc;
                                }
                        else
                                temp1->type = bt_ifunc;
                        break;
                }
}

int     alignment(TYP *tp)
{       switch(tp->type) {
                case bt_char:           return AL_CHAR;
                case bt_short:          return AL_SHORT;
                case bt_long:           return AL_LONG;
                case bt_enum:           return AL_SHORT;
                case bt_pointer:
                        if(tp->val_flag)
                                return alignment(tp->btp);
                        else
                                return AL_POINTER;
                case bt_float:          return AL_FLOAT;
                case bt_double:         return AL_DOUBLE;
                case bt_struct:
                case bt_union:          return AL_STRUCT;
                default:                return AL_CHAR;
                }
}

int     declare(TABLE *table, int al, int ilc, int ztype)
/*
 *      process declarations of the form:
 *
 *              <type>  <decl>, <decl>...;
 *
 *      leaves the declarations in the symbol table pointed to by
 *      table and returns the number of bytes declared. al is the
 *      allocation type to assign, ilc is the initial location
 *      counter. if al is sc_member then no initialization will
 *      be processed. ztype should be bt_struct for normal and in
 *      structure declarations and sc_union for in union declarations.
 */
{       SYM     *sp, *sp1;
        TYP     *dhead;
        int     nbytes;
        nbytes = 0;
        decl(table);
        dhead = head;
        for(;;) {
                declid = 0;
                decl1();
                if( declid != 0) {      /* otherwise just struct tag... */
                        sp = (SYM *) xalloc(sizeof(SYM));
                        sp->name = declid;
                        sp->storage_class = al;
                        while( (ilc + nbytes) % alignment(head)) {
                                if( al != sc_member &&
                                        al != sc_external &&
                                        al != sc_auto) {
                                        dseg();
                                        genbyte(0);
                                        }
                                ++nbytes;
                                }
                        if( al == sc_static)
                                sp->value.i = nextlabel++;
                        else if( ztype == bt_union)
                                sp->value.i = ilc;
                        else if( al != sc_auto )
                                sp->value.i = ilc + nbytes;
                        else
                                sp->value.i = -(ilc + nbytes + head->size);
                        sp->tp = head;
                        if( sp->tp->type == bt_func && 
                                sp->storage_class == sc_global )
                                sp->storage_class = sc_external;
                        if(ztype == bt_union)
                                nbytes = imax(nbytes,sp->tp->size);
                        else if(al != sc_external)
                                nbytes += sp->tp->size;
                        if( sp->tp->type == bt_ifunc &&
                                (sp1 = search(sp->name,table->head)) != 0 &&
                                sp1->tp->type == bt_func )
                                {
                                sp1->tp = sp->tp;
                                sp1->storage_class = sp->storage_class;
                                sp1->value.i = sp->value.i;
                                sp = sp1;
                                }
                        else
                                insert(sp,table);
                        if( sp->tp->type == bt_ifunc) { /* function body follows */
                                funcbody(sp);
                                return nbytes;
                                }
                        if( (al == sc_global || al == sc_static) &&
                                sp->tp->type != bt_func)
                                doinit(sp);
                        }
                if(lastst == semicolon)
                        break;
                needpunc(comma);
                if(declbegin(lastst) == 0)
                        break;
                head = dhead;
                }
        getsym();
        return nbytes;
}

int     declbegin(int st)
{       return st == star || st == id || st == openpa ||
                st == openbr;
}

void declenum(TABLE *table)
{       SYM     *sp;
        TYP     *tp;
        int     evalue;
        if( lastst == id) {
                if((sp = search(lastid,tagtable.head)) == 0) {
                        sp = (SYM *) xalloc(sizeof(SYM));
                        sp->tp = (TYP *) xalloc(sizeof(TYP));
                        sp->tp->type = bt_enum;
                        sp->tp->size = 2;
                        sp->tp->lst.head = (SYM *) sp->tp->btp = (TYP *) 0;
                        sp->storage_class = sc_type;
                        sp->name = litlate(lastid);
                        sp->tp->sname = sp->name;
                        getsym();
                        if( lastst != begin)
                                error(ERR_INCOMPLETE);
                        else    {
                                insert(sp,&tagtable);
                                getsym();
                                enumbody(table);
                                }
                        }
                else
                        getsym();
                head = sp->tp;
                }
        else    {
                tp = (TYP *) xalloc(sizeof(tp));
                tp->type = bt_short;
                if( lastst != begin)
                        error(ERR_INCOMPLETE);
                else    {
                        getsym();
                        enumbody(table);
                        }
                head = tp;
                }
}

void enumbody(TABLE *table)
{       int     evalue;
        SYM     *sp;
        evalue = 0;
        while(lastst == id) {
                sp = (SYM *) xalloc(sizeof(SYM));
                sp->value.i = evalue++;
                sp->name = litlate(lastid);
                sp->storage_class = sc_const;
                sp->tp = &stdconst;
                insert(sp,table);
                getsym();
                if( lastst == comma)
                        getsym();
                else if(lastst != end)
                        break;
                }
        needpunc(end);
}

void declstruct(int ztype)
/*
 *      declare a structure or union type. ztype should be either
 *      bt_struct or bt_union.
 */
{       SYM     *sp;
        TYP     *tp;
        int     slc;
        if(lastst == id) {
                if((sp = search(lastid,tagtable.head)) == 0) {
                        sp = (SYM *) xalloc(sizeof(SYM));
                        sp->name = litlate(lastid);
                        sp->tp = (TYP *) xalloc(sizeof(TYP));
                        sp->tp->type = ztype;
                        sp->tp->lst.head = 0;
                        sp->storage_class = sc_type;
                        sp->tp->sname = sp->name;
                        getsym();
                        if(lastst != begin)
                                error(ERR_INCOMPLETE);
                        else    {
                                insert(sp,&tagtable);
                                getsym();
                                structbody(sp->tp,ztype);
                                }
                        }
                else
                        getsym();
                head = sp->tp;
                }
        else    {
                tp = (TYP *) xalloc(sizeof(TYP));
                tp->type = ztype;
                tp->sname = 0;
                tp->lst.head = 0;
                if( lastst != begin)
                        error(ERR_INCOMPLETE);
                else    {
                        getsym();
                        structbody(tp,ztype);
                        }
                head = tp;
                }
}

void structbody(TYP *tp, int ztype)
{       int     slc;
        slc = 0;
        tp->val_flag = 1;
        while( lastst != end) {
                if(ztype == bt_struct)
                        slc += declare(&(tp->lst),sc_member,slc,ztype);
                else
                        slc = imax(slc,declare(&tp->lst,sc_member,0,ztype));
                }
        tp->size = slc;
        getsym();
}

void compile()
/*
 *      main compiler routine. this routine parses all of the
 *      declarations using declare which will call funcbody as
 *      functions are encountered.
 */
{       while(lastst != eof) {
                dodecl(sc_global);
                if( lastst != eof)
                        getsym();
                }
        dumplits();
}

void dodecl(int defclass)
{       int     size;
        for(;;) {
            switch(lastst) {
                case kw_register:
                        getsym();
                        if( defclass != sc_auto && defclass != sc_member )
                                error(ERR_ILLCLASS);
                        goto do_decl;
                case id:
                        if(defclass == sc_auto)
                                return;
/*                      else fall through to declare    */
                case kw_char: case kw_int: case kw_short: case kw_unsigned:
                case kw_long: case kw_struct: case kw_union:
                case kw_enum: case kw_void:
                case kw_float: case kw_double:
do_decl:            if( defclass == sc_global)
                        lc_static +=
                            declare(&gsyms,sc_global,lc_static,bt_struct);
                    else if( defclass == sc_auto)
                        lc_auto +=
                            declare(&lsyms,sc_auto,lc_auto,bt_struct);
                    else
                        declare(&lsyms,sc_auto,0,bt_struct);
                    break;
                case kw_static:
                        getsym();
                        if( defclass == sc_member)
                            error(ERR_ILLCLASS);
						if( defclass == sc_auto )
							lc_static += 
								declare(&lsyms,sc_static,lc_static,bt_struct);
						else
							lc_static +=
								declare(&gsyms,sc_static,lc_static,bt_struct);
                        break;
                case kw_extern:
                        getsym();
                        if( defclass == sc_member)
                            error(ERR_ILLCLASS);
                        ++global_flag;
                        declare(&gsyms,sc_external,0,bt_struct);
                        --global_flag;
                        break;
                default:
                        return;
                }
            }
}


/*
 *      expression evaluation
 *
 *      this set of routines builds a parse tree for an expression.
 *      no code is generated for the expressions during the build,
 *      this is the job of the codegen module. for most purposes
 *      expression() is the routine to call. it will allow all of
 *      the C operators. for the case where the comma operator is
 *      not valid (function parameters for instance) call exprnc().
 *
 *      each of the routines returns a pointer to a describing type
 *      structure. each routine also takes one parameter which is a
 *      pointer to an expression node by reference (address of pointer).
 *      the completed expression is returned in this pointer. all
 *      routines return either a pointer to a valid type or NULL if
 *      the hierarchy of the next operator is too low or the next
 *      symbol is not part of an expression.
 */

struct enode    *makenode(int nt, char *v1, char *v2)
/*
 *      build an expression node with a node type of nt and values
 *      v1 and v2.
 */
{       struct enode    *ep;
        ep = (struct enode *) xalloc(sizeof(struct enode));
        ep->nodetype = nt;
        ep->constflag = 0;
        ep->v.p[0] = (struct enode *) v1;
        ep->v.p[1] = (struct enode *) v2;
        return ep;
}

TYP *deref(struct enode **node, TYP *tp)
/*
 *      build the proper dereference operation for a node using the
 *      type pointer tp.
 */
{       switch( tp->type ) {
                case bt_char:
                        *node = makenode(en_b_ref,(char *) *node,0);
                        tp = &stdint;
                        break;
                case bt_short:
                case bt_enum:
                        *node = makenode(en_w_ref,(char *) *node,0);
                        tp = &stdint;
                        break;
                case bt_long:
                case bt_pointer:
                case bt_unsigned:
                        *node = makenode(en_l_ref,(char *) *node,0);
                        break;
                default:
                        error(ERR_DEREF);
                        break;
                }
        return tp;
}

TYP     *nameref(struct enode **node)
/*
 *      nameref will build an expression tree that references an
 *      identifier. if the identifier is not in the global or
 *      local symbol table then a look-ahead to the next character
 *      is done and if it indicates a function call the identifier
 *      is coerced to an external function name. non-value references
 *      generate an additional level of indirection.
 */
{       SYM             *sp;
        TYP             *tp;
        sp = gsearch(lastid);
        if( sp == 0 ) {
                while( isspace(lastch) )
                        getch();
                if( lastch == '(') {
                        ++global_flag;
                        sp = (SYM *) xalloc(sizeof(SYM));
                        sp->tp = &stdfunc;
                        sp->name = litlate(lastid);
                        sp->storage_class = sc_external;
                        insert(sp,&gsyms);
                        --global_flag;
                        tp = &stdfunc;
                        *node = makenode(en_nacon,sp->name,0);
                        (*node)->constflag = 1;
                        }
                else    {
                        tp = 0;
                        error(ERR_UNDEFINED);
                        }
                }
        else    {
                if( (tp = sp->tp) == 0 ) {
                        error(ERR_UNDEFINED);
                        return 0;       /* guard against untyped entries */
                        }
                switch( sp->storage_class ) {
                        case sc_static:
                                *node = makenode(en_labcon,(char *)sp->value.i,0);
                                (*node)->constflag = 1;
                                break;
                        case sc_global:
                        case sc_external:
                                *node = makenode(en_nacon,(char *)sp->name,0);
                                (*node)->constflag = 1;
                                break;
                        case sc_const:
                                *node = makenode(en_icon,(char *)sp->value.i,0);
                                (*node)->constflag = 1;
                                break;
                        default:        /* auto and any errors */
                                if( sp->storage_class != sc_auto)
                                        error(ERR_ILLCLASS);
                                *node = makenode(en_autocon,(char *)sp->value.i,0);
                                break;
                        }
                if( tp->val_flag == 0)
                        tp = deref(node,tp);
                }
        getsym();
        return tp;
}

struct enode    *parmlist()
/*
 *      parmlist will build a list of parameter expressions in
 *      a function call and return a pointer to the last expression
 *      parsed. since parameters are generally pushed from right
 *      to left we get just what we asked for...
 */
{       struct enode    *ep1, *ep2;
        ep1 = 0;
        while( lastst != closepa) {
                exprnc( &ep2);          /* evaluate a parameter */
                ep1 = makenode(en_void,(char *)ep2,(char *)ep1);
                if( lastst != comma)
                        break;
                getsym();
                }
        return ep1;
}

int     castbegin(st)
/*
 *      return 1 if st in set of [ kw_char, kw_short, kw_long, kw_int,
 *      kw_float, kw_double, kw_struct, kw_union ]
 */
int     st;
{       return  st == kw_char || st == kw_short || st == kw_int ||
                st == kw_long || st == kw_float || st == kw_double ||
                st == kw_struct || st == kw_union || st== kw_unsigned;
}

TYP     *primary(node)
/*
 *      primary will parse a primary expression and set the node pointer
 *      returning the type of the expression parsed. primary expressions
 *      are any of:
 *                      id
 *                      constant
 *                      string
 *                      ( expression )
 *                      primary[ expression ]
 *                      primary.id
 *                      primary->id
 *                      primary( parameter list )
 */
struct enode    **node;
{       struct enode    *pnode, *qnode, *rnode;
        SYM             *sp;
        TYP             *tptr;
        switch( lastst ) {

                case id:
                        tptr = nameref(&pnode);
                        break;
                case iconst:
                        tptr = &stdint;
                        pnode = makenode(en_icon,(char *)ival,0);
                        pnode->constflag = 1;
                        getsym();
                        break;
                case sconst:
                        tptr = &stdstring;
                        pnode = makenode(en_labcon,(char *)(long)stringlit(laststr),(char *) 0);
                        pnode->constflag = 1;
                        getsym();
                        break;
                case openpa:
                        getsym();
                        if( !castbegin(lastst) ) {
                                tptr = (TYP *) expression(&pnode);
                                needpunc(closepa);
                                }
                        else    {       /* cast operator */
                                decl(NULL); /* do cast declaration */
                                decl1();
                                tptr = head;
                                needpunc(closepa);
                                if( unary(&pnode) == 0 ) {
                                        error(ERR_IDEXPECT);
                                        tptr = 0;
                                        }
                                }
                        break;
                default:
                        return 0;
                }
        for(;;) {
                switch( lastst ) {
                        case openbr:    /* build a subscript reference */
                                if( tptr->type != bt_pointer )
                                        error(ERR_NOPOINTER);
                                else
                                        tptr = tptr->btp;
                                getsym();
                                qnode = makenode(en_icon,(char *)tptr->size,0);
                                qnode->constflag = 1;
                                expression(&rnode);
/*
 *      we could check the type of the expression here...
 */
                                qnode = makenode(en_mul,(char *) qnode,(char *) rnode);
                                qnode->constflag = rnode->constflag &&
                                        qnode->v.p[0]->constflag;
                                pnode = makenode(en_add,(char *) qnode,(char *) pnode);
                                pnode->constflag = qnode->constflag &&
                                        pnode->v.p[1]->constflag;
                                if( tptr->val_flag == 0 )
                                        tptr = deref(&pnode,tptr);
                                needpunc(closebr);
                                break;
                        case pointsto:
                                if( tptr->type != bt_pointer )
                                        error(ERR_NOPOINTER);
                                else
                                        tptr = tptr->btp;
                                if( tptr->val_flag == 0 )
                                        pnode = makenode(en_l_ref,(char *) pnode,0);
/*
 *      fall through to dot operation
 */
                        case dot:
                                getsym();       /* past -> or . */
                                if( lastst != id )
                                        error(ERR_IDEXPECT);
                                else    {
                                        sp = search(lastid,tptr->lst.head);
                                        if( sp == 0 )
                                                error(ERR_NOMEMBER);
                                        else    {
                                                tptr = sp->tp;
                                                qnode = makenode(en_icon,(char *)sp->value.i,0);
                                                qnode->constflag = 1;
                                                pnode = makenode(en_add,(char *)pnode,(char *)qnode);
                                                pnode->constflag = pnode->v.p[0]->constflag;
                                                if( tptr->val_flag == 0 )
                                                    tptr = deref(&pnode,tptr);
                                                }
                                        getsym();       /* past id */
                                        }
                                break;
                        case openpa:    /* function reference */
                                getsym();
                                if( tptr->type != bt_func &&
                                        tptr->type != bt_ifunc )
                                        error(ERR_NOFUNC);
                                else
                                        tptr = tptr->btp;
                                pnode = makenode(en_fcall,(char *)pnode,(char *)parmlist());
                                needpunc(closepa);
                                break;
                        default:
                                goto fini;
                        }
                }
fini:   *node = pnode;
        return tptr;
}

int     lvalue(node)
/*
 *      this function returns true if the node passed is an lvalue.
 *      this can be qualified by the fact that an lvalue must have
 *      one of the dereference operators as it's top node.
 */
struct enode    *node;
{       switch( node->nodetype ) {
                case en_b_ref:
                case en_w_ref:
                case en_l_ref:
                case en_ub_ref:
                case en_uw_ref:
                case en_ul_ref:
                        return 1;
                case en_cbl:
                case en_cwl:
                case en_cbw:
                        return lvalue(node->v.p[0]);
                }
        return 0;
}

TYP     *unary(struct enode **node)
/*
 *      unary evaluates unary expressions and returns the type of the
 *      expression evaluated. unary expressions are any of:
 *
 *                      primary
 *                      primary++
 *                      primary--
 *                      !unary
 *                      ~unary
 *                      ++unary
 *                      --unary
 *                      -unary
 *                      *unary
 *                      &unary
 *                      (typecast)unary
 *                      sizeof(typecast)
 *
 */
{       TYP             *tp, *tp1;
        struct enode    *ep1, *ep2;
        int             flag, i;
        flag = 0;
        switch( lastst ) {
                case autodec:
                        flag = 1;
                /* fall through to common increment */
                case autoinc:
                        getsym();
                        tp = unary(&ep1);
                        if( tp == 0 ) {
                                error(ERR_IDEXPECT);
                                return 0;
                                }
                        if( lvalue(ep1)) {
                                if( tp->type == bt_pointer )
                                        ep2 = makenode(en_icon,(char *) tp->btp->size,0);
                                else
                                        ep2 = makenode(en_icon,(char *) 1,0);
                                ep2->constflag = 1;
                                ep1 = makenode(flag ? en_assub : en_asadd,(char *)ep1,(char *)ep2);
                                }
                        else
                                error(ERR_LVALUE);
                        break;
                case minus:
                        getsym();
                        tp = unary(&ep1);
                        if( tp == 0 ) {
                                error(ERR_IDEXPECT);
                                return 0;
                                }
                        ep1 = makenode(en_uminus,(char *)ep1,0);
                        ep1->constflag = ep1->v.p[0]->constflag;
                        break;
                case not:
                        getsym();
                        tp = unary(&ep1);
                        if( tp == 0 ) {
                                error(ERR_IDEXPECT);
                                return 0;
                                }
                        ep1 = makenode(en_not,(char *)ep1,0);
                        ep1->constflag = ep1->v.p[0]->constflag;
                        break;
                case compl:
                        getsym();
                        tp = unary(&ep1);
                        if( tp == 0 ) {
                                error(ERR_IDEXPECT);
                                return 0;
                                }
                        ep1 = makenode(en_compl,(char *)ep1,0);
                        ep1->constflag = ep1->v.p[0]->constflag;
                        break;
                case star:
                        getsym();
                        tp = unary(&ep1);
                        if( tp == 0 ) {
                                error(ERR_IDEXPECT);
                                return 0;
                                }
                        if( tp->btp == 0 )
                                error(ERR_DEREF);
                        else
                                tp = tp->btp;
                        if( tp->val_flag == 0 )
                                tp = deref(&ep1,tp);
                        break;
                case and:
                        getsym();
                        tp = unary(&ep1);
                        if( tp == 0 ) {
                                error(ERR_IDEXPECT);
                                return 0;
                                }
                        if( lvalue(ep1))
                                ep1 = ep1->v.p[0];
                        tp1 = (TYP *) xalloc(sizeof(TYP));
                        tp1->size = 4;
                        tp1->type = bt_pointer;
                        tp1->btp = tp;
                        tp1->val_flag = 0;
                        tp1->lst.head = 0;
                        tp1->sname = 0;
                        tp = tp1;
                        break;
                case kw_sizeof:
                        getsym();
                        needpunc(openpa);
                        decl(0);
                        decl1();
                        if( head != 0 )
                                ep1 = makenode(en_icon,(char *)head->size,0);
                        else    {
                                error(ERR_IDEXPECT);
                                ep1 = makenode(en_icon,(char *)1,0);
                                }
                        ep1->constflag = 1;
                        tp = &stdint;
                        needpunc(closepa);
                        break;
                default:
                        tp = primary(&ep1);
                        if( tp != 0 ) {
                                if( tp->type == bt_pointer )
                                        i = tp->btp->size;
                                else
                                        i = 1;
                                if( lastst == autoinc) {
                                        if( lvalue(ep1) )
                                                ep1 = makenode(en_ainc,(char *)ep1,(char *)(long)i);
                                        else
                                                error(ERR_LVALUE);
                                        getsym();
                                        }
                                else if( lastst == autodec ) {
                                        if( lvalue(ep1) )
                                                ep1 = makenode(en_adec,(char *)ep1,(char *)(long)i);
                                        else
                                                error(ERR_LVALUE);
                                        getsym();
                                        }
                                }
                        break;
                }
        *node = ep1;
        return tp;
}

TYP     *forcefit(node1,tp1,node2,tp2)
/*
 *      forcefit will coerce the nodes passed into compatable
 *      types and return the type of the resulting expression.
 */
struct enode    **node1, **node2;
TYP             *tp1, *tp2;
{       switch( tp1->type ) {
                case bt_char:
                case bt_short:
                case bt_long:
                        if( tp2->type == bt_long ||
                                tp2->type == bt_short ||
                                tp2->type == bt_char)
                                return &stdint;
                        else if( tp2->type == bt_pointer ||
                                tp2->type == bt_unsigned )
                                return tp2;
                        break;
                case bt_pointer:
                        if( isscalar(tp2) || tp2->type == bt_pointer)
                                return tp1;
                        break;
                case bt_unsigned:
                        if( tp2->type == bt_pointer )
                                return tp2;
                        else if( isscalar(tp2) )
                                return tp1;
                        break;
                }
        error( ERR_MISMATCH );
        return tp1;
}

int     isscalar(tp)
/*
 *      this function returns true when the type of the argument is
 *      one of char, short, unsigned, or long.
 */
TYP             *tp;
{       return  tp->type == bt_char ||
                tp->type == bt_short ||
                tp->type == bt_long ||
                tp->type == bt_unsigned;
}

TYP     *multops(node)
/*
 *      multops parses the multiply priority operators. the syntax of
 *      this group is:
 *
 *              unary
 *              multop * unary
 *              multop / unary
 *              multop % unary
 */
struct enode    **node;
{       struct enode    *ep1, *ep2;
        TYP             *tp1, *tp2;
        int		      oper;
        tp1 = unary(&ep1);
        if( tp1 == 0 )
                return 0;
        while( lastst == star || lastst == divide || lastst == modop ) {
                oper = lastst;
                getsym();       /* move on to next unary op */
                tp2 = unary(&ep2);
                if( tp2 == 0 ) {
                        error(ERR_IDEXPECT);
                        *node = ep1;
                        return tp1;
                        }
                tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                switch( oper ) {
                        case star:
                                if( tp1->type == bt_unsigned )
                                        ep1 = makenode(en_umul,(char *)ep1,(char *)ep2);
                                else
                                        ep1 = makenode(en_mul,(char *)ep1,(char *)ep2);
                                break;
                        case divide:
                                if( tp1->type == bt_unsigned )
                                        ep1 = makenode(en_udiv,(char *)ep1,(char *)ep2);
                                else
                                        ep1 = makenode(en_div,(char *)ep1,(char *)ep2);
                                break;
                        case modop:
                                if( tp1->type == bt_unsigned )
                                        ep1 = makenode(en_umod,(char *)ep1,(char *)ep2);
                                else
                                        ep1 = makenode(en_mod,(char *)ep1,(char *)ep2);
                                break;
                        }
                ep1->constflag = ep1->v.p[0]->constflag &&
                        ep1->v.p[1]->constflag;
                }
        *node = ep1;
        return tp1;
}

TYP     *addops(node)
/*
 *      addops handles the addition and subtraction operators.
 */
struct enode    **node;
{       struct enode    *ep1, *ep2, *ep3;
        TYP             *tp1, *tp2;
        int             oper, i;
        tp1 = multops(&ep1);
        if( tp1 == 0 )
                return 0;
        while( lastst == plus || lastst == minus ) {
                oper = (lastst == plus);
                getsym();
                tp2 = multops(&ep2);
                if( tp2 == 0 ) {
                        error(ERR_IDEXPECT);
                        *node = ep1;
                        return tp1;
                        }
                if( tp1->type == bt_pointer ) {
                        tp2 = forcefit(0,&stdint,&ep2,tp2);
                        ep3 = makenode(en_icon,(char *)tp1->btp->size,0);
                        ep3->constflag = 1;
                        ep2 = makenode(en_mul,(char *)ep3,(char *)ep2);
                        ep2->constflag = ep2->v.p[1]->constflag;
                        }
                else if( tp2->type == bt_pointer ) {
                        tp1 = forcefit(0,&stdint,&ep1,tp1);
                        ep3 = makenode(en_icon,(char *)tp2->btp->size,0);
                        ep3->constflag = 1;
                        ep1 = makenode(en_mul,(char *)ep3,(char *)ep1);
                        ep1->constflag = ep1->v.p[1]->constflag;
                        }
                tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                ep1 = makenode( oper ? en_add : en_sub,(char *)ep1,(char *)ep2);
                ep1->constflag = ep1->v.p[0]->constflag &&
                        ep1->v.p[1]->constflag;
                }
        *node = ep1;
        return tp1;
}

TYP     *shiftop(node)
/*
 *      shiftop handles the shift operators << and >>.
 */
struct enode    **node;
{       struct enode    *ep1, *ep2;
        TYP             *tp1, *tp2;
        int             oper;
        tp1 = addops(&ep1);
        if( tp1 == 0)
                return 0;
        while( lastst == lshift || lastst == rshift) {
                oper = (lastst == lshift);
                getsym();
                tp2 = addops(&ep2);
                if( tp2 == 0 )
                        error(ERR_IDEXPECT);
                else    {
                        tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                        ep1 = makenode(oper ? en_lsh : en_rsh,(char *)ep1,(char *)ep2);
                        ep1->constflag = ep1->v.p[0]->constflag &&
                                ep1->v.p[1]->constflag;
                        }
                }
        *node = ep1;
        return tp1;
}

TYP     *relation(node)
/*
 *      relation handles the relational operators < <= > and >=.
 */
struct enode    **node;
{       struct enode    *ep1, *ep2;
        TYP             *tp1, *tp2;
        int             nt;
        tp1 = shiftop(&ep1);
        if( tp1 == 0 )
                return 0;
        for(;;) {
                switch( lastst ) {

                        case lt:
                                if( tp1->type == bt_unsigned )
                                        nt = en_ult;
                                else
                                        nt = en_lt;
                                break;
                        case gt:
                                if( tp1->type == bt_unsigned )
                                        nt = en_ugt;
                                else
                                        nt = en_gt;
                                break;
                        case leq:
                                if( tp1->type == bt_unsigned )
                                        nt = en_ule;
                                else
                                        nt = en_le;
                                break;
                        case geq:
                                if( tp1->type == bt_unsigned )
                                        nt = en_uge;
                                else
                                        nt = en_ge;
                                break;
                        default:
                                goto fini;
                        }
                getsym();
                tp2 = shiftop(&ep2);
                if( tp2 == 0 )
                        error(ERR_IDEXPECT);
                else    {
                        tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                        ep1 = makenode(nt,(char *)ep1,(char *)ep2);
                        ep1->constflag = ep1->v.p[0]->constflag &&
                                ep1->v.p[1]->constflag;
                        }
                }
fini:   *node = ep1;
        return tp1;
}

TYP     *equalops(node)
/*
 *      equalops handles the equality and inequality operators.
 */
struct enode    **node;
{       struct enode    *ep1, *ep2;
        TYP             *tp1, *tp2;
        int             oper;
        tp1 = relation(&ep1);
        if( tp1 == 0 )
                return 0;
        while( lastst == eq || lastst == neq ) {
                oper = (lastst == eq);
                getsym();
                tp2 = relation(&ep2);
                if( tp2 == 0 )
                        error(ERR_IDEXPECT);
                else    {
                        tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                        ep1 = makenode( oper ? en_eq : en_ne,(char *)ep1,(char *)ep2);
                        ep1->constflag = ep1->v.p[0]->constflag &&
                                ep1->v.p[1]->constflag;
                        }
                }
        *node = ep1;
        return tp1;
}

TYP     *binop(node,xfunc,nt,sy)
/*
 *      binop is a common routine to handle all of the legwork and
 *      error checking for bitand, bitor, bitxor, andop, and orop.
 */
struct enode    **node;
TYP             *(*xfunc)();
int             nt, sy;
{       struct enode    *ep1, *ep2;
        TYP             *tp1, *tp2;
        tp1 = (*xfunc)(&ep1);
        if( tp1 == 0 )
                return 0;
        while( lastst == sy ) {
                getsym();
                tp2 = (*xfunc)(&ep2);
                if( tp2 == 0 )
                        error(ERR_IDEXPECT);
                else    {
                        tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                        ep1 = makenode(nt,(char *)ep1,(char *)ep2);
                        ep1->constflag = ep1->v.p[0]->constflag &&
                                ep1->v.p[1]->constflag;
                        }
                }
        *node = ep1;
        return tp1;
}

TYP     *bitand(node)
/*
 *      the bitwise and operator...
 */
struct enode    **node;
{       return binop(node,equalops,en_and,and);
}

TYP     *bitxor(node)
struct enode    **node;
{       return binop(node,bitand,en_xor,uparrow);
}

TYP     *bitor(node)
struct enode    **node;
{       return binop(node,bitxor,en_or,or);
}

TYP     *andop(node)
struct enode    **node;
{       return binop(node,bitor,en_land,land);
}

TYP     *orop(node)
struct enode    **node;
{       return binop(node,andop,en_lor,lor);
}

TYP     *conditional(node)
/*
 *      this routine processes the hook operator.
 */
struct enode    **node;
{       TYP             *tp1, *tp2, *tp3;
        struct enode    *ep1, *ep2, *ep3;
        tp1 = orop(&ep1);       /* get condition */
        if( tp1 == 0 )
                return 0;
        if( lastst == hook ) {
                getsym();
                if( (tp2 = conditional(&ep2)) == 0) {
                        error(ERR_IDEXPECT);
                        goto cexit;
                        }
                needpunc(colon);
                if( (tp3 = conditional(&ep3)) == 0) {
                        error(ERR_IDEXPECT);
                        goto cexit;
                        }
                tp1 = forcefit(&ep2,tp2,&ep3,tp3);
                ep2 = makenode(en_void,(char *)ep2,(char *)ep3);
                ep1 = makenode(en_cond,(char *)ep1,(char *)ep2);
                }
cexit:  *node = ep1;
        return tp1;
}

TYP     *asnop(node)
/*
 *      asnop handles the assignment operators. currently only the
 *      simple assignment is implemented.
 */
struct enode    **node;
{       struct enode    *ep1, *ep2, *ep3;
        TYP             *tp1, *tp2;
        int             op;
        tp1 = conditional(&ep1);
        if( tp1 == 0 )
                return 0;
        for(;;) {
                switch( lastst ) {
                        case assign:
                                op = en_assign;
ascomm:                         getsym();
                                tp2 = asnop(&ep2);
ascomm2:                        if( tp2 == 0 || !lvalue(ep1) )
                                        error(ERR_LVALUE);
                                else    {
                                        tp1 = forcefit(&ep1,tp1,&ep2,tp2);
                                        ep1 = makenode(op,(char *)ep1,(char *)ep2);
                                        }
                                break;
                        case asplus:
                                op = en_asadd;
ascomm3:                        tp2 = asnop(&ep2);
                                if( tp1->type == bt_pointer ) {
                                        ep3 = makenode(en_icon,(char *)tp1->btp->size,0);
                                        ep2 = makenode(en_mul,(char *)ep2,(char *)ep3);
                                        }
                                goto ascomm;
                        case asminus:
                                op = en_assub;
                                goto ascomm3;
                        case astimes:
                                op = en_asmul;
                                goto ascomm;
                        case asdivide:
                                op = en_asdiv;
                                goto ascomm;
                        case asmodop:
                                op = en_asmod;
                                goto ascomm;
                        case aslshift:
                                op = en_aslsh;
                                goto ascomm;
                        case asrshift:
                                op = en_asrsh;
                                goto ascomm;
                        case asand:
                                op = en_asand;
                                goto ascomm;
                        case asor:
                                op = en_asor;
                                goto ascomm;
                        default:
                                goto asexit;
                        }
                }
asexit: *node = ep1;
        return tp1;
}

TYP     *exprnc(struct enode **node)
/*
 *      evaluate an expression where the comma operator is not legal.
 */
{       TYP     *tp;
        tp = asnop(node);
        if( tp == 0 )
                *node = 0;
        return tp;
}

TYP     *commaop(node)
/*
 *      evaluate the comma operator. comma operators are kept as
 *      void nodes.
 */
struct enode    **node;
{       TYP             *tp1;
        struct enode    *ep1, *ep2;
        tp1 = asnop(&ep1);
        if( tp1 == 0 )
                return 0;
        if( lastst == comma ) {
                tp1 = commaop(&ep2);
                if( tp1 == 0 ) {
                        error(ERR_IDEXPECT);
                        goto coexit;
                        }
                ep1 = makenode(en_void,(char *)ep1,(char *)ep2);
                }
coexit: *node = ep1;
        return tp1;
}

TYP     *expression(struct enode **node)
/*
 *      evaluate an expression where all operators are legal.
 */
{       TYP     *tp;
        tp = commaop(node);
        if( tp == 0 )
                *node = 0;
        return tp;
}

void funcbody(SYM *sp)
/*
 *      funcbody starts with the current symbol being either
 *      the first parameter id or the begin for the local
 *      block. If begin is the current symbol then funcbody
 *      assumes that the function has no parameters.
 */
{       char    *names[20];             /* 20 parameters maximum */
        int     nparms, poffset, i;
        SYM     *sp1, *makeint();
        global_flag = 0;
        poffset = 8;            /* size of return block */
        nparms = 0;
        if(lastst == id) {              /* declare parameters */
                while(lastst == id) {
                        names[nparms++] = litlate(lastid);
                        getsym();
                        if( lastst == comma)
                                getsym();
                        else
                                break;
                        }
                needpunc(closepa);
                dodecl(sc_member);      /* declare parameters */
                for(i = 0;i < nparms;++i) {
                        if( (sp1 = search(names[i],lsyms.head)) == 0)
                                sp1 = makeint(names[i]);
						if( sp1->tp->size < 4 )
						{
							sp1->value.i = poffset + (4 - sp1->tp->size);
							poffset += 4;
						}
						else
						{
							sp1->value.i = poffset;
							poffset += sp1->tp->size;
						}
                        sp1->storage_class = sc_auto;
					}
                }
        if(lastst != begin)
                error(ERR_BLOCK);
        else    {
                cseg();
                gen_strlab(sp->name);
                block();
                funcbottom();
                }
        global_flag = 1;
}

SYM     *makeint(name)
char    *name;
{       SYM     *sp;
        TYP     *tp;
        sp = (SYM *) xalloc(sizeof(SYM));
        tp = (TYP *)xalloc(sizeof(TYP));
        tp->type = bt_long;
        tp->size = 4;
        tp->btp = (TYP *) tp->lst.head = 0;
        tp->sname = 0;
        sp->name = name;
        sp->storage_class = sc_auto;
        sp->tp = tp;
        insert(sp,&lsyms);
        return sp;
}

void check_table(head)
SYM     *head;
{
#if 0
       while( head != 0 ) {
                if (head->storage_class == sc_ulabel )
                        // fprintf(list,"*** UNDEFINED LABEL - %s\n",head->name);
                head = head->next;
                }
#endif
}

void funcbottom()
{       nl();
        check_table(lsyms.head);
        lc_auto = 0;
#if 0
        // fprintf(list,"\n\n*** local symbol table ***\n\n");
        list_table(&lsyms,0);
        // fprintf(list,"\n\n\n");
#endif
        release_local();        /* release local symbols */
}

void block()
{       needpunc(begin);
        dodecl(sc_auto);
		cseg();
        genfunc((struct snode *) compound());
        flush_peep();
}

// gencode (shorten?)

struct amode    *gen_expr();            /* forward declaration */

struct amode    *make_label(lab)
/*
 *      construct a reference node for an internal label number.
 */
int     lab;
{       struct enode    *lnode;
        struct amode    *ap;
        lnode = (struct enode *) xalloc(sizeof(struct enode));
        lnode->nodetype = en_labcon;
        lnode->v.i = lab;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_direct;
        ap->offset = lnode;
        return ap;
}

struct amode    *make_immed(i)
/*
 *      make a node to reference an immediate value i.
 */
int     i;
{       struct amode    *ap;
        struct enode    *ep;
        ep = (struct enode *) xalloc(sizeof(struct enode));
        ep->nodetype = en_icon;
        ep->v.i = i;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_immed;
        ap->offset = ep;
        return ap;
}

struct amode    *make_offset(node)
/*
 *      make a direct reference to a node.
 */
struct enode    *node;
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_direct;
        ap->offset = node;
        return ap;
}
        
void make_legal(ap,flags,size)
/*
 *      make_legal will coerce the addressing mode in ap1 into a
 *      mode that is satisfactory for the flag word.
 */
struct amode    *ap;
int             flags, size;
{       struct amode    *ap2;
        if( ((flags & F_VOL) == 0) || ap->tempflag )
                {
                switch( ap->mode )
                        {
                        case am_immed:
                                if( flags & F_IMMED )
                                        return;         /* mode ok */
                                break;
                        case am_areg:
                                if( flags & F_AREG )
                                        return;
                                break;
                        case am_dreg:
                                if( flags & F_DREG )
                                        return;
                                break;
                        case am_ind:    case am_indx:
                        case am_indx2:  case am_xpc:
                        case am_direct: case am_indx3:
                                if( flags & F_MEM )
                                        return;
                                break;
                        }
                }
        if( flags & F_DREG )
                {
                freeop(ap);             /* maybe we can use it... */
                ap2 = (struct amode *) temp_data();      /* allocate to dreg */
                gen_code(op_move,size,ap,ap2);
                ap->mode = am_dreg;
                ap->preg = ap2->preg;
                ap->deep = ap2->deep;
                ap->tempflag = 1;
                return;
                }
        if( size == 1 )
                {
                freeop(ap);
                ap2 = (struct amode *) temp_data();
                gen_code(op_move,1,ap,ap2);
                gen_code(op_ext,2,ap2,0);
                freeop(ap);
                ap->mode = ap2->mode;
                ap->preg = ap2->preg;
                ap->deep = ap2->deep;
                size = 2;
                }
        freeop(ap);
        ap2 = (struct amode *) temp_addr();
        gen_code(op_move,size,ap,ap2);
        ap->mode = am_areg;
        ap->preg = ap2->preg;
        ap->deep = ap2->deep;
        ap->tempflag = 1;
}

void do_extend(ap,isize,osize,flags)
/*
 *      if isize is not equal to osize then the operand ap will be
 *      loaded into a register (if not already) and if osize is
 *      greater than isize it will be extended to match.
 */
struct amode    *ap;
int             isize, osize, flags;
{       if( isize == osize )
                return;
        if( ap->mode != am_areg && ap->mode != am_dreg )
                make_legal(ap,flags & (F_AREG | F_DREG),isize);
        if( ap->mode == am_areg )
                return;         /* extend is automagic */
        switch( isize )
                {
                case 1:
                        gen_code(op_ext,2,ap,0);
                case 2:
                        if( osize == 4 )
                                gen_code(op_ext,4,ap,0);
                }
}

int     isshort(node)
/*
 *      return true if the node passed can be generated as a short
 *      offset.
 */
struct enode    *node;
{       return node->nodetype == en_icon &&
                (node->v.i >= -65536/2 && node->v.i <= 65535/2);
}

int     isbyte(node)
/*
 *      return true if the node passed can be evaluated as a byte
 *      offset.
 */
struct enode    *node;
{       return node->nodetype == en_icon &&
                (-128 <= node->v.i && node->v.i <= 127);
}

struct amode    *gen_index(node)
/*
 *      generate code to evaluate an index node (^+) and return
 *      the addressing mode of the result. This routine takes no
 *      flags since it always returns either am_ind or am_indx.
 */
struct enode    *node;
{       struct amode    *ap1, *ap2;
        if( node->v.p[0]->nodetype == en_tempref &&
                node->v.p[1]->nodetype == en_tempref &&
                ( node->v.p[0]->v.i >= 8 || node->v.p[1]->v.i >= 8 ))
                {       /* both nodes are registers, one is address */
                if( node->v.p[0]->v.i < 8 )
                        {
                        ap1 = gen_expr(node->v.p[1],F_AREG,4);
                        ap1->sreg = node->v.p[0]->v.i;
                        ap1->mode = am_indx2;   /* 0(Ax,Dx) */
                        ap1->offset = makenode(en_icon,0,0);
                        return ap1;
                        }
                ap1 = gen_expr(node->v.p[0],F_AREG,4);
                ap2 = gen_expr(node->v.p[1],F_AREG | F_DREG,4);
                if( ap2->mode == am_dreg )
                        {
                        ap1->mode = am_indx2;
                        ap1->sreg = ap2->preg;
                        }
                else
                        {
                        ap1->mode = am_indx3;
                        ap1->sreg = ap2->preg;
                        }
                ap1->offset = makenode(en_icon,0,0);
                return ap1;
                }
        ap1 = gen_expr(node->v.p[0],F_AREG | F_IMMED,4);
        if( ap1->mode == am_immed && isshort(ap1->offset) )
                {
                ap2 = gen_expr(node->v.p[1],F_AREG,4);
                ap2->mode = am_indx;
                ap2->offset = ap1->offset;
                return ap2;
                }
        ap2 = gen_expr(node->v.p[1],F_ALL,4);   /* get right op */
        if( ap2->mode == am_immed && isshort(ap2->offset) &&
			ap1->mode == am_areg ) /* make am_indx */
                {
                ap2->mode = am_indx;
                ap2->preg = ap1->preg;
                ap2->deep = ap1->deep;
                return ap2;
                }
        validate(ap1);
        make_legal(ap1,F_AREG | F_VOL,4);
        gen_code(op_add,4,ap2,ap1);             /* add left to address reg */
        ap1->mode = am_ind;             /* make indirect */
        freeop(ap2);                    /* release any temps in ap2 */
        return ap1;                     /* return indirect */
}

struct amode    *gen_deref(node,flags,size)
/*
 *      return the addressing mode of a dereferenced node.
 */
struct enode    *node;
int             flags, size;
{       struct amode    *ap1;
        int             siz1;
        switch( node->nodetype )        /* get load size */
                {
                case en_b_ref:
                        siz1 = 1;
                        break;
                case en_w_ref:
                        siz1 = 2;
                        break;
                case en_l_ref:
                        siz1 = 4;
                        break;
                }
        if( node->v.p[0]->nodetype == en_add )
                {
                ap1 = gen_index(node->v.p[0]);
                do_extend(ap1,siz1,size,flags);
                make_legal(ap1,flags,size);
                return ap1;
                }
        else if( node->v.p[0]->nodetype == en_autocon )
                {
                ap1 = (struct amode *) xalloc(sizeof(struct amode));
                ap1->mode = am_indx;
                ap1->preg = 6;
                ap1->offset = makenode(en_icon,(char *)node->v.p[0]->v.i,0);
                do_extend(ap1,siz1,size,flags);
                make_legal(ap1,flags,size);
                return ap1;
                }
        ap1 = gen_expr(node->v.p[0],F_AREG | F_IMMED,4); /* generate address */
        if( ap1->mode == am_areg )
                {
                ap1->mode = am_ind;
                do_extend(ap1,siz1,size,flags);
                make_legal(ap1,flags,size);
                return ap1;
                }
        ap1->mode = am_direct;
        do_extend(ap1,siz1,size,flags);
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode    *gen_unary(node,flags,size,op)
/*
 *      generate code to evaluate a unary minus or complement.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap;
        ap = gen_expr(node->v.p[0],F_DREG | F_VOL,size);
        gen_code(op,size,ap,0);
        make_legal(ap,flags,size);
        return ap;
}

struct amode    *gen_binary(node,flags,size,op)
/*
 *      generate code to evaluate a binary node and return 
 *      the addressing mode of the result.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap1, *ap2;
        ap1 = gen_expr(node->v.p[0],F_VOL | F_DREG | F_AREG,size);
        ap2 = gen_expr(node->v.p[1],F_ALL,size);
        validate(ap1);          /* in case push occurred */
        gen_code(op,size,ap2,ap1);
        freeop(ap2);
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode    *gen_xbin(node,flags,size,op)
/*
 *      generate code to evaluate a restricted binary node and return 
 *      the addressing mode of the result.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap1, *ap2;
        ap1 = gen_expr(node->v.p[0],F_VOL | F_DREG,size);
        ap2 = gen_expr(node->v.p[1],F_DREG,size);
        validate(ap1);          /* in case push occurred */
        gen_code(op,size,ap2,ap1);
        freeop(ap2);
        make_legal(ap1,flags,size);
        return ap1;
}
struct amode    *gen_shift(node,flags,size,op)
/*
 *      generate code to evaluate a shift node and return the
 *      address mode of the result.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap1, *ap2;
        ap1 = gen_expr(node->v.p[0],F_DREG | F_VOL,size);
        ap2 = gen_expr(node->v.p[1],F_DREG | F_IMMED,1);
        validate(ap1);
        gen_code(op,size,ap2,ap1);
        freeop(ap2);
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode    *gen_modiv(node,flags,size,op,modflag)
/*
 *      generate code to evaluate a mod operator or a divide
 *      operator. these operations are done on only long
 *      divisors and word dividends so that the 68000 div
 *      instruction can be used.
 */
struct enode    *node;
int             flags, op, size, modflag;
{       struct amode    *ap1, *ap2;
        if( node->v.p[0]->nodetype == en_icon )
                swap_nodes(node);
        ap1 = gen_expr(node->v.p[0],F_DREG | F_VOL,4);
        ap2 = gen_expr(node->v.p[1],F_ALL,2);
        validate(ap1);
        gen_code(op,0,ap2,ap1);
        if( modflag )
                gen_code(op_swap,0,ap1,0);
        gen_code(op_ext,4,ap1,0);
        make_legal(ap1,flags,4);
        freeop(ap2);
        return ap1;
}

void swap_nodes(struct enode *node)
/*
 *      exchange the two operands in a node.
 */
{       struct enode    *temp;
        temp = node->v.p[0];
        node->v.p[0] = node->v.p[1];
        node->v.p[1] = temp;
}

struct amode    *gen_mul(node,flags,size,op)
/*
 *      generate code to evaluate a multiply node. both operands
 *      are treated as words and the result is long and is always
 *      in a register so that the 68000 mul instruction can be used.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap1, *ap2;
        if( node->v.p[0]->nodetype == en_icon )
                swap_nodes(node);
        ap1 = gen_expr(node->v.p[0],F_DREG | F_VOL,2);
        ap2 = gen_expr(node->v.p[1],F_ALL,2);
        validate(ap1);
        gen_code(op,0,ap2,ap1);
        freeop(ap2);
        make_legal(ap1,flags,4);
        return ap1;
}

struct amode    *gen_hook(node,flags,size)
/*
 *      generate code to evaluate a condition operator node (?:)
 */
struct enode    *node;
int             flags, size;
{       struct amode    *ap1, *ap2;
        int             false_label, end_label;
        false_label = nextlabel++;
        end_label = nextlabel++;
        flags = (flags & (F_AREG | F_DREG)) | F_VOL;
        falsejp(node->v.p[0],false_label);
        node = node->v.p[1];
        ap1 = gen_expr(node->v.p[0],flags,size);
        freeop(ap1);
        gen_code(op_bra,0,make_label(end_label),0);
        gen_label(false_label);
        ap2 = gen_expr(node->v.p[1],flags,size);
        if( !equal_address(ap1,ap2) )
                {
                freeop(ap2);
                if( ap1->mode == am_dreg )
                        temp_data();
                else
                        temp_addr();
                gen_code(op_move,size,ap2,ap1);
                }
        gen_label(end_label);
        return ap1;
}

struct amode    *gen_asadd(node,flags,size,op)
/*
 *      generate a plus equal or a minus equal node.
 */
struct enode    *node;
int             flags,size,op;
{       struct amode    *ap1, *ap2;
        int             ssize, mask0, mask1;
        ssize = natural_size(node->v.p[0]);
        if( ssize > size )
                size = ssize;
        ap1 = gen_expr(node->v.p[0],F_ALL,ssize);
        ap2 = gen_expr(node->v.p[1],F_DREG | F_AREG | F_IMMED,size);
        validate(ap1);
        gen_code(op,ssize,ap2,ap1);
        freeop(ap2);
        do_extend(ap1,ssize,size);
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode    *gen_aslogic(node,flags,size,op)
/*
 *      generate a and equal or a or equal node.
 */
struct enode    *node;
int             flags,size,op;
{       struct amode    *ap1, *ap2, *ap3;
        int             ssize, mask0, mask1;
        ssize = natural_size(node->v.p[0]);
        if( ssize > size )
                size = ssize;
        ap1 = gen_expr(node->v.p[0],F_ALL,ssize);
        ap2 = gen_expr(node->v.p[1],F_DREG | F_IMMED,size);
        validate(ap1);
        if( ap1->mode != am_areg )
                gen_code(op,ssize,ap2,ap1);
        else
                {
                ap3 = (struct amode *) temp_data();
                gen_code(op_move,4,ap1,ap3);
                gen_code(op,size,ap2,ap3);
                gen_code(op_move,size,ap3,ap1);
                freeop(ap3);
                }
        freeop(ap2);
        do_extend(ap1,ssize,size);
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode *gen_asshift(node,flags,size,op)
/*
 *      generate shift equals operators.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap1, *ap2, *ap3;
        ap1 = gen_expr(node->v.p[0],F_ALL,size);
        if( ap1->mode != am_dreg )
                {
                ap3 = (struct amode *) temp_data();
                gen_code(op_move,size,ap1,ap3);
                }
        else
                ap3 = ap1;
        ap2 = gen_expr(node->v.p[1],F_DREG | F_IMMED,size);
        validate(ap3);
        gen_code(op,size,ap2,ap3);
        freeop(ap2);
        if( ap3 != ap1 )
                {
                gen_code(op_move,size,ap3,ap1);
                freeop(ap3);
                }
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode    *gen_asmul(node,flags,size)
/*
 *      generate a *= node.
 */
struct enode    *node;
int             flags, size;
{       struct amode    *ap1, *ap2, *ap3;
        int             siz1;
        siz1 = natural_size(node->v.p[0]);
        ap1 = gen_expr(node->v.p[1],F_DREG | F_VOL,2);
        ap2 = gen_expr(node->v.p[0],F_ALL,siz1);
        if( siz1 == 1 || ap2->mode == am_areg )
                {
                ap3 = (struct amode *) temp_data();
                gen_code(op_move,siz1,ap2,ap3);
                if( siz1 == 1 )
                        gen_code(op_ext,2,ap3,0);
                freeop(ap3);
                }
        else
                ap3 = ap2;
        gen_code(op_muls,0,ap3,ap1);
        gen_code(op_move,siz1,ap1,ap2);
        freeop(ap2);
        return ap1;
}

struct amode    *gen_asmodiv(node,flags,size,op)
/*
 *      generate /= and %= nodes.
 */
struct enode    *node;
int             flags, size, op;
{       struct amode    *ap1, *ap2, *ap3;
        int             siz1;
        siz1 = natural_size(node->v.p[0]);
        ap1 = (struct amode *) temp_data();
        ap2 = gen_expr(node->v.p[0],F_ALL,siz1);
        validate(ap1);
        gen_code(op_move,siz1,ap2,ap1);
        do_extend(ap1,siz1,4);
        ap3 = gen_expr(node->v.p[1],F_ALL & ~F_AREG,2);
        validate(ap2);
        validate(ap1);
        gen_code(op_divs,0,ap3,ap1);
        freeop(ap3);
        if( op != op_divs )
                gen_code(op_swap,0,ap1,0);
        gen_code(op_ext,4,ap1,0);
        gen_code(op_move,siz1,ap1,ap2);
        freeop(ap2);
        make_legal(ap1,flags,size);
        return ap1;
}

struct amode    *gen_assign(node,flags,size)
/*
 *      generate code for an assignment node. if the size of the
 *      assignment destination is larger than the size passed then
 *      everything below this node will be evaluated with the
 *      assignment size.
 */
struct enode    *node;
int             flags, size;
{       struct amode    *ap1, *ap2;
        int             ssize;
        switch( node->v.p[0]->nodetype )
                {
                case en_b_ref:
                        ssize = 1;
                        break;
                case en_w_ref:
                        ssize = 2;
                        break;
                case en_l_ref:
                case en_tempref:
                        ssize = 4;
                        break;
                }
        if( ssize > size )
                size = ssize;
        ap2 = gen_expr(node->v.p[1],F_ALL,size);
        ap1 = gen_expr(node->v.p[0],F_ALL,ssize);
        validate(ap2);
        gen_code(op_move,ssize,ap2,ap1);
        freeop(ap1);
        return ap2;
}

struct amode    *gen_aincdec(node,flags,size,op)
/*
 *      generate an auto increment or decrement node. op should be
 *      either op_add (for increment) or op_sub (for decrement).
 */
struct enode    *node;
int             flags, size;
{       struct amode    *ap1, *ap2;
        int             siz1;
        siz1 = natural_size(node->v.p[0]);
        if( flags & F_NOVALUE )         /* dont need result */
                {
                ap1 = gen_expr(node->v.p[0],F_ALL,siz1);
                gen_code(op,siz1,make_immed(node->v.p[1]),ap1);
                freeop(ap1);
                return ap1;
                }
        if( flags & F_DREG )
                ap1 = (struct amode *) temp_data();
        else
                ap1 = (struct amode *) temp_addr();
        ap2 = gen_expr(node->v.p[0],F_ALL,siz1);
        validate(ap1);
        gen_code(op_move,siz1,ap2,ap1);
        gen_code(op,siz1,make_immed(node->v.p[1]),ap2);
        freeop(ap2);
        do_extend(ap1,siz1,size);
        return ap1;
}

void push_param(ep)
/*
 *      push the operand expression onto the stack.
 */
struct enode    *ep;
{       struct amode    *ap;
        ap = gen_expr(ep,F_ALL,4);
        gen_code(op_move,4,ap,push);
        freeop(ap);
}

int     gen_parms(plist)
/*
 *      push a list of parameters onto the stack and return the
 *      number of parameters pushed.
 */
struct enode    *plist;
{       int     i;
        i = 0;
        while( plist != 0 )
                {
                push_param(plist->v.p[0]);
                plist = plist->v.p[1];
                ++i;
                }
        return i;
}

struct amode    *gen_fcall(node,flags)
/*
 *      generate a function call node and return the address mode
 *      of the result.
 */
struct enode    *node;
{       struct amode    *ap, *result;
        int             i;
        result = (struct amode *) temp_addr();
        temp_addr();                    /* push any used addr temps */
        freeop(result); freeop(result);
        result = (struct amode *) temp_data();
        temp_data(); temp_data();       /* push any used data registers */
        freeop(result); freeop(result); freeop(result);
        i = gen_parms(node->v.p[1]);    /* generate parameters */
        if( node->v.p[0]->nodetype == en_nacon )
                gen_code(op_jsr,0,make_offset(node->v.p[0]),0);
        else
                {
                ap = gen_expr(node->v.p[0],F_AREG,4);
                ap->mode = am_ind;
                freeop(ap);
                gen_code(op_jsr,0,ap,0);
                }
        if( i != 0 )
                gen_code(op_add,4,make_immed(i * 4),makeareg(7));
        if( flags & F_DREG )
                result = (struct amode *) temp_data();
        else
                result = (struct amode *) temp_addr();
        if( result->preg != 0 || (flags & F_DREG) == 0 )
                gen_code(op_move,4,makedreg(0),result);
        return result;
}

struct amode    *gen_expr(node,flags,size)
/*
 *      general expression evaluation. returns the addressing mode
 *      of the result.
 */
struct enode    *node;
int             flags, size;
{       struct amode    *ap1, *ap2;
        int             lab0, lab1;
        int             natsize;
        if( node == 0 )
                {
                // printf("DIAG - null node in gen_expr.\n");
                return 0;
                }
        switch( node->nodetype )
                {
                case en_icon:
                case en_labcon:
                case en_nacon:
                        ap1 = (struct amode *) xalloc(sizeof(struct amode));
                        ap1->mode = am_immed;
                        ap1->offset = node;
                        make_legal(ap1,flags,size);
                        return ap1;
                case en_autocon:
                        ap1 = (struct amode *) temp_addr();
                        ap2 = (struct amode *) xalloc(sizeof(struct amode));
                        ap2->mode = am_indx;
                        ap2->preg = 6;          /* frame pointer */
                        ap2->offset = node;     /* use as constant node */
                        gen_code(op_lea,0,ap2,ap1);
                        make_legal(ap1,flags,size);
                        return ap1;             /* return reg */
                case en_b_ref:
                case en_w_ref:
                case en_l_ref:
                        return gen_deref(node,flags,size);
                case en_tempref:
                        ap1 = (struct amode *) xalloc(sizeof(struct amode));
                        if( node->v.i < 8 )
                                {
                                ap1->mode = am_dreg;
                                ap1->preg = node->v.i;
                                }
                        else
                                {
                                ap1->mode = am_areg;
                                ap1->preg = node->v.i - 8;
                                }
                        ap1->tempflag = 0;      /* not a temporary */
                        make_legal(ap1,flags,size);
                        return ap1;
                case en_uminus:
                        return gen_unary(node,flags,size,op_neg);
                case en_compl:
                        return gen_unary(node,flags,size,op_not);
                case en_add:
                        return gen_binary(node,flags,size,op_add);
                case en_sub:
                        return gen_binary(node,flags,size,op_sub);
                case en_and:
                        return gen_binary(node,flags,size,op_and);
                case en_or:
                        return gen_binary(node,flags,size,op_or);
				case en_xor:
						return gen_xbin(node,flags,size,op_eor);
                case en_mul:
                        return gen_mul(node,flags,size,op_muls);
                case en_umul:
                        return gen_mul(node,flags,size,op_mulu);
                case en_div:
                        return gen_modiv(node,flags,size,op_divs,0);
                case en_udiv:
                        return gen_modiv(node,flags,size,op_divu,0);
                case en_mod:
                        return gen_modiv(node,flags,size,op_divs,1);
                case en_umod:
                        return gen_modiv(node,flags,size,op_divu,1);
                case en_lsh:
                        return gen_shift(node,flags,size,op_asl);
                case en_rsh:
                        return gen_shift(node,flags,size,op_asr);
                case en_asadd:
                        return gen_asadd(node,flags,size,op_add);
                case en_assub:
                        return gen_asadd(node,flags,size,op_sub);
                case en_asand:
                        return gen_aslogic(node,flags,size,op_and);
                case en_asor:
                        return gen_aslogic(node,flags,size,op_or);
                case en_aslsh:
                        return gen_asshift(node,flags,size,op_asl);
                case en_asrsh:
                        return gen_asshift(node,flags,size,op_asr);
                case en_asmul:
                        return gen_asmul(node,flags,size);
                case en_asdiv:
                        return gen_asmodiv(node,flags,size,op_divs);
                case en_asmod:
                        return gen_asmodiv(node,flags,size,op_muls);
                case en_assign:
                        return gen_assign(node,flags,size);
                case en_ainc:
                        return gen_aincdec(node,flags,size,op_add);
                case en_adec:
                        return gen_aincdec(node,flags,size,op_sub);
                case en_land:   case en_lor:
                case en_eq:     case en_ne:
                case en_lt:     case en_le:
                case en_gt:     case en_ge:
                case en_ult:    case en_ule:
                case en_ugt:    case en_uge:
                case en_not:
                        lab0 = nextlabel++;
                        lab1 = nextlabel++;
                        falsejp(node,lab0);
                        ap1 = (struct amode *) temp_data();
                        gen_code(op_moveq,0,make_immed(1),ap1);
                        gen_code(op_bra,0,make_label(lab1),0);
                        gen_label(lab0);
                        gen_code(op_clr,4,ap1,0);
                        gen_label(lab1);
                        return ap1;
                case en_cond:
                        return gen_hook(node,flags,size);
                case en_void:
                        natsize = natural_size(node->v.p[0]);
                        freeop(gen_expr(node->v.p[0],F_ALL | F_NOVALUE,natsize));
                        return gen_expr(node->v.p[1],flags,size);
                case en_fcall:
                        return gen_fcall(node,flags);
                default:
                        // printf("DIAG - uncoded node in gen_expr.\n");
                        return 0;
                }
}

int     natural_size(node)
/*
 *      return the natural evaluation size of a node.
 */
struct enode    *node;
{       int     siz0, siz1;
        if( node == 0 )
                return 0;
        switch( node->nodetype )
                {
                case en_icon:
                        if( -128 <= node->v.i && node->v.i <= 127 )
                                return 1;
                        if( -32768 <= node->v.i && node->v.i <= 32767 )
                                return 2;
                        return 4;
                case en_fcall:  case en_labcon:
                case en_nacon:  case en_autocon:
                case en_l_ref:  case en_tempref:
                case en_cbl:    case en_cwl:
                        return 4;
                case en_b_ref:
                        return 1;
                case en_cbw:
                case en_w_ref:
                        return 2;
                case en_not:    case en_compl:
                case en_uminus: case en_assign:
                case en_ainc:   case en_adec:
                        return natural_size(node->v.p[0]);
                case en_add:    case en_sub:
                case en_mul:    case en_div:
                case en_mod:    case en_and:
                case en_or:     case en_xor:
                case en_lsh:    case en_rsh:
                case en_eq:     case en_ne:
                case en_lt:     case en_le:
                case en_gt:     case en_ge:
                case en_land:   case en_lor:
                case en_asadd:  case en_assub:
                case en_asmul:  case en_asdiv:
                case en_asmod:  case en_asand:
                case en_asor:   case en_aslsh:
                case en_asrsh:
                        siz0 = natural_size(node->v.p[0]);
                        siz1 = natural_size(node->v.p[1]);
                        if( siz1 > siz0 )
                                return siz1;
                        else
                                return siz0;
                case en_void:   case en_cond:
                        return natural_size(node->v.p[1]);
                default:
                        // printf("DIAG - natural size error.\n");
                        break;
                }
        return 0;
}

void gen_compare(node)
/*
 *      generate code to do a comparison of the two operands of
 *      node.
 */
struct enode    *node;
{       struct amode    *ap1, *ap2;
        int             size;
        size = natural_size(node);
        ap1 = gen_expr(node->v.p[0],F_AREG | F_DREG, size);
        ap2 = gen_expr(node->v.p[1],F_ALL,size);
        validate(ap1);
        gen_code(op_cmp,size,ap2,ap1);
        freeop(ap2);
        freeop(ap1);
}

void truejp(node,label)
/*
 *      generate a jump to label if the node passed evaluates to
 *      a true condition.
 */
struct enode    *node;
int             label;
{       struct amode    *ap1;
        int             siz1;
        int             lab0;
        if( node == 0 )
                return;
        switch( node->nodetype )
                {
                case en_eq:
                        gen_compare(node);
                        gen_code(op_beq,0,make_label(label),0);
                        break;
                case en_ne:
                        gen_compare(node);
                        gen_code(op_bne,0,make_label(label),0);
                        break;
                case en_lt:
                        gen_compare(node);
                        gen_code(op_blt,0,make_label(label),0);
                        break;
                case en_le:
                        gen_compare(node);
                        gen_code(op_ble,0,make_label(label),0);
                        break;
                case en_gt:
                        gen_compare(node);
                        gen_code(op_bgt,0,make_label(label),0);
                        break;
                case en_ge:
                        gen_compare(node);
                        gen_code(op_bge,0,make_label(label),0);
                        break;
                case en_ult:
                        gen_compare(node);
                        gen_code(op_blo,0,make_label(label),0);
                        break;
                case en_ule:
                        gen_compare(node);
                        gen_code(op_bls,0,make_label(label),0);
                        break;
                case en_ugt:
                        gen_compare(node);
                        gen_code(op_bhi,0,make_label(label),0);
                        break;
                case en_uge:
                        gen_compare(node);
                        gen_code(op_bhs,0,make_label(label),0);
                        break;
                case en_land:
                        lab0 = nextlabel++;
                        falsejp(node->v.p[0],lab0);
                        truejp(node->v.p[1],label);
                        gen_label(lab0);
                        break;
                case en_lor:
                        truejp(node->v.p[0],label);
                        truejp(node->v.p[1],label);
                        break;
                case en_not:
                        falsejp(node->v.p[0],label);
                        break;
                default:
                        siz1 = natural_size(node);
                        ap1 = gen_expr(node,F_ALL,siz1);
                        gen_code(op_tst,siz1,ap1,0);
                        freeop(ap1);
                        gen_code(op_bne,0,make_label(label),0);
                        break;
                }
}

void falsejp(struct enode *node, int label)
/*
 *      generate code to execute a jump to label if the expression
 *      passed is false.
 */
{       struct amode    *ap;
        int             siz1;
        int             lab0;
        if( node == 0 )
                return;
        switch( node->nodetype )
                {
                case en_eq:
                        gen_compare(node);
                        gen_code(op_bne,0,make_label(label),0);
                        break;
                case en_ne:
                        gen_compare(node);
                        gen_code(op_beq,0,make_label(label),0);
                        break;
                case en_lt:
                        gen_compare(node);
                        gen_code(op_bge,0,make_label(label),0);
                        break;
                case en_le:
                        gen_compare(node);
                        gen_code(op_bgt,0,make_label(label),0);
                        break;
                case en_gt:
                        gen_compare(node);
                        gen_code(op_ble,0,make_label(label),0);
                        break;
                case en_ge:
                        gen_compare(node);
                        gen_code(op_blt,0,make_label(label),0);
                        break;
                case en_ult:
                        gen_compare(node);
                        gen_code(op_bhs,0,make_label(label),0);
                        break;
                case en_ule:
                        gen_compare(node);
                        gen_code(op_bhi,0,make_label(label),0);
                        break;
                case en_ugt:
                        gen_compare(node);
                        gen_code(op_bls,0,make_label(label),0);
                        break;
                case en_uge:
                        gen_compare(node);
                        gen_code(op_blo,0,make_label(label),0);
                        break;
                case en_land:
                        falsejp(node->v.p[0],label);
                        falsejp(node->v.p[1],label);
                        break;
                case en_lor:
                        lab0 = nextlabel++;
                        truejp(node->v.p[0],lab0);
                        falsejp(node->v.p[1],label);
                        gen_label(lab0);
                        break;
                case en_not:
                        truejp(node->v.p[0],label);
                        break;
                default:
                        siz1 = natural_size(node);
                        ap = gen_expr(node,F_ALL,siz1);
                        gen_code(op_tst,siz1,ap,0);
                        freeop(ap);
                        gen_code(op_beq,0,make_label(label),0);
                        break;
                }
}


struct amode    *makedreg(int r)
/*
 *      make an address reference to a data register.
 */
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_dreg;
        ap->preg = r;
        return ap;
}

struct amode    *makeareg(int r)
/*
 *      make an address reference to an address register.
 */
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_areg;
        ap->preg = r;
        return ap;
}

struct amode    *make_mask(mask)
/*
 *      generate the mask address structure.
 */
int     mask;
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_mask;
        ap->offset = (struct enode *) (long) mask;
        return ap;
}

struct amode    *make_direct(i)
/*
 *      make a direct reference to an immediate value.
 */
int     i;
{       return make_offset(makenode(en_icon,(char *) (long) i,0));
}

struct amode    *make_strlab(s)
/*
 *      generate a direct reference to a string label.
 */
char    *s;
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_direct;
        ap->offset = makenode(en_nacon,s,0);
        return ap;
}

void genwhile(stmt)
/*
 *      generate code to evaluate a while statement.
 */
struct snode    *stmt;
{       int     lab1, lab2;
        initstack();            /* initialize temp registers */
        lab1 = contlab;         /* save old continue label */
        lab2 = breaklab;        /* save old break label */
        contlab = nextlabel++;  /* new continue label */
        gen_label(contlab);
        if( stmt->s1 != 0 )      /* has block */
                {
                breaklab = nextlabel++;
                initstack();
                falsejp(stmt->exp,breaklab);
                genstmt(stmt->s1);
                gen_code(op_bra,0,make_label(contlab),0);
                gen_label(breaklab);
                breaklab = lab2;        /* restore old break label */
                }
        else					        /* no loop code */
                {
                initstack();
                truejp(stmt->exp,contlab);
                }
        contlab = lab1;         /* restore old continue label */
}

void gen_for(stmt)
/*
 *      generate code to evaluate a for loop
 */
struct snode    *stmt;
{       int     old_break, old_cont, exit_label, loop_label;
        old_break = breaklab;
        old_cont = contlab;
        loop_label = nextlabel++;
        exit_label = nextlabel++;
        contlab = loop_label;
        initstack();
        if( stmt->label != 0 )
                gen_expr(stmt->label,F_ALL | F_NOVALUE
                        ,natural_size(stmt->label));
        gen_label(loop_label);
        initstack();
        if( stmt->exp != 0 )
                falsejp(stmt->exp,exit_label);
        if( stmt->s1 != 0 )
		{
                breaklab = exit_label;
                genstmt(stmt->s1);
		}
        initstack();
        if( stmt->s2 != 0 )
                gen_expr(stmt->s2,F_ALL | F_NOVALUE,natural_size(stmt->s2));
        gen_code(op_bra,0,make_label(loop_label),0);
        breaklab = old_break;
        contlab = old_cont;
        gen_label(exit_label);
}

void genif(stmt)
/*
 *      generate code to evaluate an if statement.
 */
struct snode    *stmt;
{       int     lab1, lab2, oldbreak;
        lab1 = nextlabel++;     /* else label */
        lab2 = nextlabel++;     /* exit label */
        oldbreak = breaklab;    /* save break label */
        initstack();            /* clear temps */
        falsejp(stmt->exp,lab1);
        if( stmt->s1 != 0 && stmt->s1->next != 0 )
                if( stmt->s2 != 0 )
                        breaklab = lab2;
                else
                        breaklab = lab1;
        genstmt(stmt->s1);
        if( stmt->s2 != 0 )             /* else part exists */
                {
                gen_code(op_bra,0,make_label(lab2),0);
                gen_label(lab1);
                if( stmt->s2 == 0 || stmt->s2->next == 0 )
                        breaklab = oldbreak;
                else
                        breaklab = lab2;
                genstmt(stmt->s2);
                gen_label(lab2);
                }
        else                            /* no else code */
                gen_label(lab1);
        breaklab = oldbreak;
}

void gendo(stmt)
/*
 *      generate code for a do - while loop.
 */
struct snode    *stmt;
{       int     oldcont, oldbreak;
        oldcont = contlab;
        oldbreak = breaklab;
        contlab = nextlabel++;
        gen_label(contlab);
        if( stmt->s1 != 0 && stmt->s1->next != 0 )
                {
                breaklab = nextlabel++;
                genstmt(stmt->s1);      /* generate body */
                initstack();
                truejp(stmt->exp,contlab);
                gen_label(breaklab);
                }
        else
                {
                genstmt(stmt->s1);
                initstack();
                truejp(stmt->exp,contlab);
                }
        breaklab = oldbreak;
        contlab = oldcont;
}

void call_library(lib_name)
/*
 *      generate a call to a library routine.
 */
char    *lib_name;
{       SYM     *sp;
        sp = gsearch(lib_name);
        if( sp == 0 )
                {
                ++global_flag;
                sp = (SYM *) xalloc(sizeof(SYM));
                sp->tp = &stdfunc;
                sp->name = lib_name;
                sp->storage_class = sc_external;
                insert(sp,&gsyms);
                --global_flag;
                }
        gen_code(op_jsr,0,make_strlab(lib_name),0);
}

void genswitch(struct snode *stmt)
/*
 *      generate a linear search switch statement.
 */
{       int             curlab;
        struct snode    *defcase;
        struct amode    *ap;
        curlab = nextlabel++;
        defcase = 0;
        initstack();
        ap = gen_expr(stmt->exp,F_DREG | F_VOL,4);
        if( ap->preg != 0 )
                gen_code(op_move,4,ap,makedreg(0));
        stmt = stmt->s1;
        call_library("c%switch");
        while( stmt != 0 )
                {
                if( stmt->s2 )          /* default case ? */
                        {
                        stmt->label = curlab;
                        defcase = stmt;
                        }
                else
                        {
                        gen_code(op_dc,4,make_label(curlab),
                                make_direct(stmt->label));
                        stmt->label = curlab;
                        }
                if( stmt->s1 != 0 && stmt->next != 0 )
                        curlab = nextlabel++;
                stmt = stmt->next;
                }
        if( defcase == 0 )
                gen_code(op_dc,4,make_direct(0),make_label(breaklab));
        else
                gen_code(op_dc,4,make_direct(0),make_label(defcase->label));
}

void gencase(stmt)
/*
 *      generate all cases for a switch statement.
 */
struct snode    *stmt;
{       while( stmt != 0 )
                {
                if( stmt->s1 != 0 )
                        {
                        gen_label(stmt->label);
                        genstmt(stmt->s1);
                        }
                else if( stmt->next == 0 )
                        gen_label(stmt->label);
                stmt = stmt->next;
                }
}

void genxswitch(stmt)
/*
 *      analyze and generate best switch statement.
 */
struct snode    *stmt;
{       int     oldbreak;
        oldbreak = breaklab;
        breaklab = nextlabel++;
        genswitch(stmt);
        gencase(stmt->s1);
        gen_label(breaklab);
        breaklab = oldbreak;
}

void genreturn(stmt)
/*
 *      generate a return statement.
 */
struct snode    *stmt;
{       struct amode    *ap;
        if( stmt != 0 && stmt->exp != 0 )
                {
                initstack();
                ap = gen_expr(stmt->exp,F_ALL,4);
                if( ap->mode != am_dreg || ap->preg != 0 )
                        gen_code(op_move,4,ap,makedreg(0));
                }
        if( retlab == -1 )
                {
                retlab = nextlabel++;
                gen_label(retlab);
                if( save_mask != 0 )
                        gen_code(op_movem,4,pop,make_mask(save_mask));
                gen_code(op_unlk,0,makeareg(6),0);
                gen_code(op_rts,0,0,0);
                }
        else
                gen_code(op_bra,0,make_label(retlab),0);
}

void genstmt(struct snode *stmt)
/*
 *      genstmt will generate a statement and follow the next pointer
 *      until the block is generated.
 */
{       while( stmt != 0 )
                {
                switch( stmt->stype )
                        {
                        case st_label:
                                gen_label(stmt->label);
                                break;
                        case st_goto:
                                gen_code(op_bra,0,make_label(stmt->label),0);
                                break;
                        case st_expr:
                                initstack();
                                gen_expr(stmt->exp,F_ALL | F_NOVALUE,
                                        natural_size(stmt->exp));
                                break;
                        case st_return:
                                genreturn(stmt);
                                break;
                        case st_if:
                                genif(stmt);
                                break;
                        case st_while:
                                genwhile(stmt);
                                break;
                        case st_for:
                                gen_for(stmt);
                                break;
                        case st_continue:
                                gen_code(op_bra,0,make_label(contlab),0);
                                break;
                        case st_break:
                                gen_code(op_bra,0,make_label(breaklab),0);
                                break;
                        case st_switch:
                                genxswitch(stmt);
                                break;
                        default:
                                // printf("DIAG - unknown statement.\n");
                                break;
                        }
                stmt = stmt->next;
                }
}

void genfunc(struct snode *stmt)
/*
 *      generate a function body.
 */
{       retlab = contlab = breaklab = -1;
		if( lc_auto & 1 )	/* if frame size odd */
			++lc_auto;		/* make it even */
        gen_code(op_link,0,makeareg(6),make_immed(-lc_auto));
//        opt1(stmt);
//        genstmt(stmt);
        genreturn(stmt);
}

int     isalnum(c)
char    c;
{       return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') ||
                (c >= '0' && c <= '9');
}

int     isidch(c)
char    c;
{       return isalnum(c) || c == '_' || c == '$';
}

int     isspace(c)
char    c;
{       return c == ' ' || c == '\t' || c == '\n' || c == 0x0d;
}

int     isdigit(c)
char    c;
{       return (c >= '0' && c <= '9');
}

initsym()
{       lptr = iline;
        iline[0] = 0;
        numerrs = 0;
        total_errors = 0;
        lineno = 0;
}

int     getline(listflag)
int     listflag;
{       int     rv;
	char	Buffer[80];
        if( lineno > 0 && listflag) {
                // fprintf(list,"%6d\t%s",lineno,iline);
                while(numerrs--)
		{
                   new_ONTIC_screen ();     
                   sprintf (Buffer, "Error (%d) in line %d", errno[numerrs], lineno);
                   DisplayString (Buffer, 10, 42);
                   ShowError (errno[numerrs], 10, 52);
                   ReadKey ();
		}
                numerrs = 0;
                }
        ++lineno;
        rv = (fgets(iline,131,input) == 0);
        if( rv && incldepth > 0 ) {
                // fclose(input);
                input = inclfile[--incldepth];
                lineno = inclline[incldepth];
                return getline(0);
                }
        if( rv )
                return 1;
        lptr = iline;
        if(iline[0] == '#')
                return preprocess();
        return 0;
}

/*
 *      getch - basic get character routine.
 */
int     getch()
{       while((lastch = *lptr++) == 0) {
                if( lstackptr > 0 ) {
                        lptr = linstack[--lstackptr];
                        lastch = chstack[lstackptr];
                        return lastch;
                        }
                if(getline(incldepth == 0))
                        return lastch = -1;
                }
        return lastch;
}
 
/*
 *      error - print error information
 */
void error(int n)
{       errno[numerrs++] = n;
        ++total_errors;
}

/*
 *      getid - get an identifier.
 *
 *      identifiers are any isidch conglomerate
 *      that doesn't start with a numeric character.
 *      this set INCLUDES keywords.
 */
int     getid()
{       register int    i;
        i = 0;
        while(isidch(lastch)) {
                if(i < 19)
                        lastid[i++] = lastch;
                getch();
                }
        lastid[i] = 0;
        lastst = id;
}
 
/*
 *      getsch - get a character in a quoted string.
 *
 *      this routine handles all of the escape mechanisms
 *      for characters in strings and character constants.
 */
int     getsch()        /* return an in-quote character */
{       register int    i, j;
        if(lastch == '\n')
                return -1;
        if(lastch != '\\') {
                i = lastch;
                getch();
                return i;
                }
        getch();        /* get an escaped character */
        if(isdigit(lastch)) {
                i = 0;
                for(i = 0;j < 3;++j) {
                        if(lastch <= '7' && lastch >= '0')
                                i = (i << 3) + lastch - '0';
                        else
                                break;
                        getch();
                        }
                return i;
                }
        i = lastch;
        getch();
        switch(i) {
                case '\n':
                        getch();
                        return getsch();
                case 'b':
                        return '\b';
                case 'f':
                        return '\f';
                case 'n':
                        return '\n';
                case 'r':
                        return '\r';
		case 't':
			return '\t';
                default:
                        return i;
                }
}

int     radix36(c)
char    c;
{       if(isdigit(c))
                return c - '0';
        if(c >= 'a' && c <= 'z')
                return c - 'a' + 10;
        if(c >= 'A' && c <= 'Z')
                return c - 'A' + 10;
        return -1;
}
 
/*
 *      getbase - get an integer in any base.
 */
void getbase(b)
{       register int    i, j;
        i = 0;
        while(isalnum(lastch)) {
                if((j = radix36(lastch)) < b) {
                        i = i * b + j;
                        getch();
                        }
                else break;
                }
        ival = i;
        lastst = iconst;
}
 
/*
 *      getfrac - get fraction part of a floating number.
 */

void getfrac()
{       double  frmul;
        /* frmul = 0.1; */
        while(isdigit(lastch)) {
                /* rval += frmul * (lastch - '0'); */
                getch();
                /* frmul *= 0.1; */
                }
}

 
/*
 *      getexp - get exponent part of floating number.
 *
 *      this algorithm is primative but usefull.  Floating
 *      exponents are limited to +/-255 but most hardware
 *      won't support more anyway.
 */
getexp()
{       double  expo, exmul;
        /* expo = 1.0; 
         */
        if(lastst != rconst)
                rval = ival;
        if(lastch = '-') {
        /*      exmul = 0.1; 
         */
                getch();
                }
/*        else
 *                exmul = 10.0; 
 */
        getbase(10);
        if(ival > 255)
                error(ERR_FPCON);
        else
                while(ival--);
/*                        
 *       expo *= exmul;
 *       rval *= expo;
 */
}
 
/*
 *      getnum - get a number from input.
 *
 *      getnum handles all of the numeric input. it accepts
 *      decimal, octal, hexidecimal, and floating point numbers.
 */
void getnum()
{       register int    i, j, k;
        i = 0;
        if(lastch == '0') {
                getch();
                if(lastch == 'x' || lastch == 'X') {
                        getch();
                        getbase(16);
                        }
                else getbase(8);
                }
        else    {
                getbase(10);
                if(lastch == '.') {
                        getch();
                        rval = ival;    /* float the integer part */
                        getfrac();      /* add the fractional part */
                        lastst = rconst;
                        }
                if(lastch == 'e' || lastch == 'E') {
                        getch();
                        getexp();       /* get the exponent */
                        }
                }
}
 
/*
 *      getsym - get next symbol from input stream.
 *
 *      getsym is the basic lexical analyzer.  It builds
 *      basic tokens out of the characters on the input
 *      stream and sets the following global variables:
 *
 *      lastch:         A look behind buffer.
 *      lastst:         type of last symbol read.
 *      laststr:        last string constant read.
 *      lastid:         last identifier read.
 *      ival:           last integer constant read.
 *      rval:           last real constant read.
 *
 *      getsym should be called for all your input needs...
 */
int     getsym()
{       register int    i, j, k;
        SYM             *sp;
restart:        /* we come back here after comments */
        while(isspace(lastch))
                getch();
        if( lastch == -1)
                lastst = eof;
        else if(isdigit(lastch))
                getnum();
        else if(isidch(lastch)) {
                getid();
                if( (sp = search(lastid,defsyms.head)) != 0 ) {
                        linstack[lstackptr] = lptr;
                        chstack[lstackptr++] = lastch;
                        lptr = sp->value.s;
                        getch();
                        goto restart;
                        }
                }
        else switch(lastch) {
                case '+':
                        getch();
                        if(lastch == '+') {
                                getch();
                                lastst = autoinc;
                                }
                        else if(lastch == '=') {
                                getch();
                                lastst = asplus;
                                }
                        else lastst = plus;
                        break;
                case '-':
                        getch();
                        if(lastch == '-') {
                                getch();
                                lastst = autodec;
                                }
                        else if(lastch == '=') {
                                getch();
                                lastst = asminus;
                                }
                        else if(lastch == '>') {
                                getch();
                                lastst = pointsto;
                                }
                        else lastst = minus;
                        break;
                case '*':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = astimes;
                                }
                        else lastst = star;
                        break;
                case '/':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = asdivide;
                                }
                        else if(lastch == '*') {
                                getch();
                                for(;;) {
                                        if(lastch == '*') {
                                                getch();
                                                if(lastch == '/') {
                                                        getch();
                                                        goto restart;
                                                        }
                                                }
                                        else
                                                getch();
                                        }
                                }
                        else lastst = divide;
                        break;
                case '^':
                        getch();
                        lastst = uparrow;
                        break;
                case ';':
                        getch();
                        lastst = semicolon;
                        break;
                case ':':
                        getch();
                        lastst = colon;
                        break;
                case '=':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = eq;
                                }
                        else lastst = assign;
                        break;
                case '>':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = geq;
                                }
                        else if(lastch == '>') {
                                getch();
                                if(lastch == '=') {
                                        getch();
                                        lastst = asrshift;
                                        }
                                else lastst = rshift;
                                }
                        else lastst = gt;
                        break;
                case '<':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = leq;
                                }
                        else if(lastch == '<') {
                                getch();
                                if(lastch == '=') {
                                        getch();
                                        lastst = aslshift;
                                        }
                                else lastst = lshift;
                                }
                        else lastst = lt;
                        break;
                case '\'':
                        getch();
                        ival = getsch();        /* get a string char */
                        if(lastch != '\'')
                                error(ERR_SYNTAX);
                        else
                                getch();
                        lastst = iconst;
                        break;
                case '\"':
                        getch();
                        for(i = 0;i < MAX_STRLEN;++i) {
                                if(lastch == '\"')
                                        break;
                                if((j = getsch()) == -1)
                                        break;
                                else
                                        laststr[i] = j;
                                }
                        laststr[i] = 0;
                        lastst = sconst;
                        if(lastch != '\"')
                                error(ERR_SYNTAX);
                        else
                                getch();
                        break;
                case '!':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = neq;
                                }
                        else lastst = not;
                        break;
                case '%':
                        getch();
                        if(lastch == '=') {
                                getch();
                                lastst = asmodop;
                                }
                        else lastst = modop;
                        break;
                case '~':
                        getch();
                        lastst = compl;
                        break;
                case '.':
                        getch();
                        lastst = dot;
                        break;
                case ',':
                        getch();
                        lastst = comma;
                        break;
                case '&':
                        getch();
                        if( lastch == '&') {
                                lastst = land;
                                getch();
                                }
                        else if( lastch == '=') {
                                lastst = asand;
                                getch();
                                }
                        else
                                lastst = and;
                        break;
                case '|':
                        getch();
                        if(lastch == '|') {
                                lastst = lor;
                                getch();
                                }
                        else if( lastch == '=') {
                                lastst = asor;
                                getch();
                                }
                        else
                                lastst = or;
                        break;
                case '(':
                        getch();
                        lastst = openpa;
                        break;
                case ')':
                        getch();
                        lastst = closepa;
                        break;
                case '[':
                        getch();
                        lastst = openbr;
                        break;
                case ']':
                        getch();
                        lastst = closebr;
                        break;
                case '{':
                        getch();
                        lastst = begin;
                        break;
                case '}':
                        getch();
                        lastst = end;
                        break;
                case '?':
                        getch();
                        lastst = hook;
                        break;
                default:
                        getch();
                        error(ERR_ILLCHAR);
                        goto restart;   /* get a real token */
                }
        if(lastst == id)
                searchkw();
}

void needpunc(enum e_sym p)
{       if( lastst == p)
                getsym();
        else
                error(ERR_PUNCT);
}

void doinit(SYM *sp)
{       dseg();                 /* initialize into data segment */
        nl();                   /* start a new line in object */
        if(sp->storage_class == sc_static)
                put_label(sp->value.i);
        else
                gen_strlab(sp->name);
        if( lastst != assign)
                genstorage(sp->tp->size);
        else    {
                getsym();
                inittype(sp->tp);
                }
        endinit();
}

int     inittype(tp)
TYP     *tp;
{       int     nbytes;
        switch(tp->type) {

                case bt_char:
                        nbytes = initchar();
                        break;
                case bt_short:
                case bt_enum:
                        nbytes = initshort();
                        break;
                case bt_pointer:
                        if( tp->val_flag)
                                nbytes = initarray(tp);
                        else
                                nbytes = initpointer();
                        break;
                case bt_long:
                        nbytes = initlong();
                        break;
                case bt_struct:
                        nbytes = initstruct(tp);
                        break;
                default:
                        error(ERR_NOINIT);
                        nbytes = 0;
                }
        return nbytes;
}

int initarray(tp)
TYP     *tp;
{       int     nbytes;
        char    *p;
        nbytes = 0;
        if( lastst == begin) {
                getsym();               /* skip past the brace */
                while(lastst != end) {
                        nbytes += inittype(tp->btp);
                        if( lastst == comma)
                                getsym();
                        else if( lastst != end)
                                error(ERR_PUNCT);
                        }
                getsym();               /* skip closing brace */
                }
        else if( lastst == sconst && tp->btp->type == bt_char) {
                nbytes = strlen(laststr) + 1;
                p = laststr;
                while( *p )
                        genbyte(*p++);
                genbyte(0);
                getsym();
                }
        else if( lastst != semicolon)
                error(ERR_ILLINIT);
        if( nbytes < tp->size) {
                genstorage( tp->size - nbytes);
                nbytes = tp->size;
                }
        else if( tp->size != 0 && nbytes > tp->size)
                error(ERR_INITSIZE);    /* too many initializers */
        return nbytes;
}

int initstruct(tp)
TYP     *tp;
{       SYM     *sp;
        int     nbytes;
        needpunc(begin);
        nbytes = 0;
        sp = tp->lst.head;      /* start at top of symbol table */
        while(sp != 0) {
                while(nbytes < sp->value.i)
                {
                        /* align properly */
                        genbyte(0);
                        nbytes++;
                }
                nbytes += inittype(sp->tp);
                if( lastst == comma)
                        getsym();
                else if(lastst == end)
                        break;
                else
                        error(ERR_PUNCT);
                sp = sp->next;
                }
        if( nbytes < tp->size)
                genstorage( tp->size - nbytes);
        needpunc(end);
        return tp->size;
}

int initchar()
{       genbyte(intexpr());
        return 1;
}

int initshort()
{       genword(intexpr());
        return 2;
}

int initlong()
{       genlong(intexpr());
        return 4;
}

int initpointer()
{       SYM     *sp;
        if(lastst == and) {     /* address of a variable */
                getsym();
                if( lastst != id)
                        error(ERR_IDEXPECT);
                else if( (sp = gsearch(lastid)) == 0)
                        error(ERR_UNDEFINED);
                else    {
                        getsym();
                        if( lastst == plus || lastst == minus)
                                genref(sp,intexpr());
                        else
                                genref(sp,0);
                        if( sp->storage_class == sc_auto)
                                error(ERR_NOINIT);
                        }
                }
        else if(lastst == sconst) {
                gen_labref(stringlit(laststr));
                getsym();
                }
        else
                genlong(intexpr());
        endinit();
        return 4;       /* pointers are 4 bytes long */
}

void endinit()
{       if( lastst != comma && lastst != semicolon && lastst != end) {
                error(ERR_PUNCT);
                while( lastst != comma && lastst != semicolon && lastst != end)
                        getsym();
                }
}

int intexpr()       /* simple integer value */
{       int     temp;
        SYM     *sp;
        if(lastst == id) {
                sp = search(lastid,lsyms.head);
                if( sp == NULL)
                        sp = search(lastid,gsyms.head);
                if(sp == NULL) {
                        error(ERR_UNDEFINED);
                        getsym();
                        return 0;
                        }
                if(sp->storage_class != sc_const) {
                        error(ERR_SYNTAX);
                        getsym();
                        return 0;
                        }
                getsym();
                return sp->value.i;
                }
        else if(lastst == iconst) {
                temp = ival;
                getsym();
                return temp;
                }
        getsym();
        error(ERR_SYNTAX);
        return 0;
}

void put_sc(scl)
int     scl;
{
#if 0
       switch(scl) {
                case sc_static:
                        // fprintf(list,"Static      ");
                        break;
                case sc_auto:
                        // fprintf(list,"Auto        ");
                        break;
                case sc_global:
                        // fprintf(list,"Global      ");
                        break;
                case sc_external:
                        // fprintf(list,"External    ");
                        break;
                case sc_type:
                        // fprintf(list,"Type        ");
                        break;
                case sc_const:
                        // fprintf(list,"Constant    ");
                        break;
                case sc_member:
                        // fprintf(list,"Member      ");
                        break;
                case sc_label:
                        // fprintf(list,"Label");
                        break;
                case sc_ulabel:
                        // fprintf(list,"Undefined label");
                        break;
                }
#endif
}

void put_ty(tp)
TYP     *tp;
{
#if 0
       if(tp == 0)
                return;
        switch(tp->type) {
                case bt_char:
                        // fprintf(list,"Char");
                        break;
                case bt_short:
                        // fprintf(list,"Short");
                        break;
                case bt_enum:
                        // fprintf(list,"enum ");
                        goto ucont;
                case bt_long:
                        // fprintf(list,"Long");
                        break;
                case bt_unsigned:
                        // fprintf(list,"unsigned long");
                        break;
                case bt_float:
                        // fprintf(list,"Float");
                        break;
                case bt_double:
                        // fprintf(list,"Double");
                        break;
                case bt_pointer:
                        if( tp->val_flag == 0)
                                // fprintf(list,"Pointer to ");
                        else
                                // fprintf(list,"Array of ");
                        put_ty(tp->btp);
                        break;
                case bt_union:
                        // fprintf(list,"union ");
                        goto ucont;
                case bt_struct:
                        // fprintf(list,"struct ");
ucont:                  if(tp->sname == 0)
                                // fprintf(list,"<no name> ");
                        else
                                // fprintf(list,"%s ",tp->sname);
                        break;
                case bt_ifunc:
                case bt_func:
                        // fprintf(list,"Function returning ");
                        put_ty(tp->btp);
                        break;
                }
#endif
}

void list_var(sp,i)
SYM     *sp;
int     i;
{
#if 0
       int     j;
        for(j = i; j; --j)
                // fprintf(list,"    ");
        // fprintf(list,"%-10s =%06x ",sp->name,sp->value.u);
        if( sp->storage_class == sc_external)
                // fprintf(output,"\tglobal\t%s\n",sp->name);
        else if( sp->storage_class == sc_global )
                // fprintf(output,"\tglobal\t%s\n",sp->name);
        put_sc(sp->storage_class);
        put_ty(sp->tp);
        // fprintf(list,"\n");
        if(sp->tp == 0)
                return;
        if((sp->tp->type == bt_struct || sp->tp->type == bt_union) &&
                sp->storage_class == sc_type)
                list_table(&(sp->tp->lst),i+1);
#endif
}

void list_table(t,i)
TABLE   *t;
int  i;
{
#if 0
     SYM     *sp;
        sp = t->head;
        while(sp != NULL) {
                list_var(sp,i);
                sp = sp->next;
                }
#endif
}

struct blk {
        struct blk      *next;
        char            m[1];           /* memory area */
        };

int      glbsize = 0,    /* size left in current global block */
         locsize = 0,    /* size left in current local block */
         glbindx = 0,    /* global index */
         locindx = 0;    /* local index */
  
struct blk       *locblk = 0,    /* pointer to local block */
                 *glbblk = 0;    /* pointer to global block */

char    *xalloc(int siz)
{       struct blk      *bp;
        char            *rv;
	if( siz & 1 )		/* if odd size */
		siz += 1;	/* make it even */
        if( global_flag ) {
                if( glbsize >= siz ) {
                        rv = &(glbblk->m[glbindx]);
                        glbsize -= siz;
                        glbindx += siz;
                        return rv;
                        }
                else    {
                        bp = calloc(1,sizeof(struct blk) + 2047);
			if( bp == NULL )
			{
                                // printf(" not enough memory.\n");
				exit(1);
			}
                        bp->next = glbblk;
                        glbblk = bp;
                        glbsize = 2048 - siz;
                        glbindx = siz;
                        return glbblk->m;
                        }
                }
        else    {
                if( locsize >= siz ) {
                        rv = &(locblk->m[locindx]);
                        locsize -= siz;
                        locindx += siz;
                        return rv;
                        }
                else    {
                        bp = calloc(1,sizeof(struct blk) + 2047);
			if( bp == NULL )
			{
                                // printf(" not enough local memory.\n");
				exit(1);
			}
                        bp->next = locblk;
                        locblk = bp;
                        locsize = 2048 - siz;
                        locindx = siz;
                        return locblk->m;
                        }
                }
}

void release_local()
{       struct blk      *bp1, *bp2;
        int             blkcnt;
        blkcnt = 0;
        bp1 = locblk;
        while( bp1 != 0 ) {
                bp2 = bp1->next;
                free( bp1 );
                ++blkcnt;
                bp1 = bp2;
                }
        locblk = 0;
        locsize = 0;
        lsyms.head = 0;
        // printf(" releasing %d bytes local tables.\n",blkcnt * 2048);
}

void release_global()
{       struct blk      *bp1, *bp2;
        int             blkcnt;
        bp1 = glbblk;
        blkcnt = 0;
        while( bp1 != 0 ) {
                bp2 = bp1->next;
                free(bp1);
                ++blkcnt;
                bp1 = bp2;
                }
        glbblk = 0;
        glbsize = 0;
        gsyms.head = 0;         /* clear global symbol table */
        // printf(" releasing %d bytes global tables.\n",blkcnt * 2048);
        strtab = 0;             /* clear literal table */
}


// optimize (shorten?)
void dooper(node)
/*
 *      dooper will execute a constant operation in a node and
 *      modify the node to be the result of the operation.
 */
struct enode    **node;
{
#if 0
       struct enode    *ep;
        ep = *node;
        switch( ep->nodetype ) {
                case en_add:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i + ep->v.p[1]->v.i;
                        break;
                case en_sub:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i - ep->v.p[1]->v.i;
                        break;
                case en_mul:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i * ep->v.p[1]->v.i;
                        break;
                case en_div:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i / ep->v.p[1]->v.i;
                        break;
                case en_lsh:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i << ep->v.p[1]->v.i;
                        break;
                case en_rsh:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i >> ep->v.p[1]->v.i;
                        break;
                case en_and:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i & ep->v.p[1]->v.i;
                        break;
                case en_or:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i | ep->v.p[1]->v.i;
                        break;
                case en_xor:
                        ep->nodetype = en_icon;
                        ep->v.i = ep->v.p[0]->v.i ^ ep->v.p[1]->v.i;
                        break;
                }
#endif
}

int     pwrof2(i)
/*
 *      return which power of two i is or -1.
 */
int     i;
{       int     p, q;
        q = 2;
        p = 1;
        while( q > 0 )
                {
                if( q == i )
                        return p;
                q <<= 1;
                ++p;
                }
        return -1;
}

int     mod_mask(i)
/*
 *      make a mod mask for a power of two.
 */
int     i;
{       int     m;
        m = 0;
        while( i-- )
                m = (m << 1) | 1;
        return m;
}

void opt0(node)
/*
 *      opt0 - delete useless expressions and combine constants.
 *
 *      opt0 will delete expressions such as x + 0, x - 0, x * 0,
 *      x * 1, 0 / x, x / 1, x mod 0, etc from the tree pointed to
 *      by node and combine obvious constant operations. It cannot
 *      combine name and label constants but will combine icon type
 *      nodes.
 */
struct enode    **node;
{
#if 0
  struct enode    *ep;
        int             val, sc;
        ep = *node;
        if( ep == 0 )
                return;
        switch( (*node)->nodetype ) {
                case en_b_ref:
                case en_w_ref:          /* optimize unary node */
                case en_l_ref:
				case en_cbw:
				case en_cbl:
				case en_cwl:
				case en_ainc:
				case en_adec:
				case en_not:
				case en_compl:
                        opt0( &((*node)->v.p[0]));
                        return;
                case en_uminus:
                        opt0( &(ep->v.p[0]));
                        if( ep->v.p[0]->nodetype == en_icon )
                                {
                                ep->nodetype = en_icon;
                                ep->v.i = -ep->v.p[0]->v.i;
                                }
                        return;
                case en_add:
                case en_sub:
                        opt0(&(ep->v.p[0]));
                        opt0(&(ep->v.p[1]));
                        if( ep->v.p[0]->nodetype == en_icon ) {
                                if( ep->v.p[1]->nodetype == en_icon ) {
                                        dooper(node);
                                        return;
                                        }
                                if( ep->v.p[0]->v.i == 0 ) {
					if( ep->nodetype == en_sub )
					{
						ep->v.p[0] = ep->v.p[1];
                                        	ep->nodetype = en_uminus;
					}
					else
						*node = ep->v.p[1];
                                        return;
                                        }
                                }
                        else if( ep->v.p[1]->nodetype == en_icon ) {
                                if( ep->v.p[1]->v.i == 0 ) {
                                        *node = ep->v.p[0];
                                        return;
                                        }
                                }
                        return;
                case en_mul:
                        opt0(&(ep->v.p[0]));
                        opt0(&(ep->v.p[1]));
                        if( ep->v.p[0]->nodetype == en_icon ) {
                                if( ep->v.p[1]->nodetype == en_icon ) {
                                        dooper(node);
                                        return;
                                        }
                                val = ep->v.p[0]->v.i;
                                if( val == 0 ) {
                                        *node = ep->v.p[0];
                                        return;
                                        }
                                if( val == 1 ) {
                                        *node = ep->v.p[1];
                                        return;
                                        }
                                sc = pwrof2(val);
                                if( sc != -1 )
                                        {
                                        swap_nodes(ep);
                                        ep->v.p[1]->v.i = sc;
                                        ep->nodetype = en_lsh;
                                        }
                                }
                        else if( ep->v.p[1]->nodetype == en_icon ) {
                                val = ep->v.p[1]->v.i;
                                if( val == 0 ) {
                                        *node = ep->v.p[1];
                                        return;
                                        }
                                if( val == 1 ) {
                                        *node = ep->v.p[0];
                                        return;
                                        }
                                sc = pwrof2(val);
                                if( sc != -1 )
                                        {
                                        ep->v.p[1]->v.i = sc;
                                        ep->nodetype = en_lsh;
                                        }
                                }
                        break;
                case en_div:
                        opt0(&(ep->v.p[0]));
                        opt0(&(ep->v.p[1]));
                        if( ep->v.p[0]->nodetype == en_icon ) {
                                if( ep->v.p[1]->nodetype == en_icon ) {
                                        dooper(node);
                                        return;
                                        }
                                if( ep->v.p[0]->v.i == 0 ) {    /* 0/x */
                                        *node = ep->v.p[0];
                                        return;
                                        }
                                }
                        else if( ep->v.p[1]->nodetype == en_icon ) {
                                val = ep->v.p[1]->v.i;
                                if( val == 1 ) {        /* x/1 */
                                        *node = ep->v.p[0];
                                        return;
                                        }
                                sc = pwrof2(val);
                                if( sc != -1 )
                                        {
                                        ep->v.p[1]->v.i = sc;
                                        ep->nodetype = en_rsh;
                                        }
                                }
                        break;
                case en_mod:
                        opt0(&(ep->v.p[0]));
                        opt0(&(ep->v.p[1]));
                        if( ep->v.p[1]->nodetype == en_icon )
                                {
                                if( ep->v.p[0]->nodetype == en_icon )
                                        {
                                        dooper(node);
                                        return;
                                        }
                                sc = pwrof2(ep->v.p[1]->v.i);
                                if( sc != -1 )
                                        {
                                        ep->v.p[1]->v.i = mod_mask(sc);
                                        ep->nodetype = en_and;
                                        }
                                }
                        break;
                case en_and:    case en_or:
                case en_xor:    case en_rsh:
                case en_lsh:
                        opt0(&(ep->v.p[0]));
                        opt0(&(ep->v.p[1]));
                        if( ep->v.p[0]->nodetype == en_icon &&
                                ep->v.p[1]->nodetype == en_icon )
                                dooper(node);
                        break;
                case en_land:   case en_lor:
				case en_lt:		case en_le:
				case en_gt:		case en_ge:
				case en_eq:		case en_ne:
                case en_asand:  case en_asor:
                case en_asadd:  case en_assub:
                case en_asmul:  case en_asdiv:
                case en_asmod:  case en_asrsh:
                case en_aslsh:  case en_cond:
                case en_fcall:  case en_void:
                case en_assign:
                        opt0(&(ep->v.p[0]));
                        opt0(&(ep->v.p[1]));
                        break;
                }
#endif
}

int     xfold(node)
/*
 *      xfold will remove constant nodes and return the values to
 *      the calling routines.
 */
struct enode    *node;
{
#if 0
  int     i;
        if( node == 0 )
                return 0;
        switch( node->nodetype )
                {
                case en_icon:
                        i = node->v.i;
                        node->v.i = 0;
                        return i;
                case en_add:
                        return xfold(node->v.p[0]) + xfold(node->v.p[1]);
                case en_sub:
                        return xfold(node->v.p[0]) - xfold(node->v.p[1]);
                case en_mul:
                        if( node->v.p[0]->nodetype == en_icon )
                                return xfold(node->v.p[1]) * node->v.p[0]->v.i;
                        else if( node->v.p[1]->nodetype == en_icon )
                                return xfold(node->v.p[0]) * node->v.p[1]->v.i;
                        else return 0;
                case en_lsh:
                        if( node->v.p[0]->nodetype == en_icon )
                                return xfold(node->v.p[1]) << node->v.p[0]->v.i;
                        else if( node->v.p[1]->nodetype == en_icon )
                                return xfold(node->v.p[0]) << node->v.p[1]->v.i;
                        else return 0;
                case en_uminus:
                        return - xfold(node->v.p[0]);
                case en_rsh:    case en_div:
                case en_mod:    case en_asadd:
                case en_assub:  case en_asmul:
                case en_asdiv:  case en_asmod:
                case en_and:    case en_land:
                case en_or:     case en_lor:
                case en_xor:    case en_asand:
                case en_asor:   case en_void:
                case en_fcall:  case en_assign:
                        fold_const(&node->v.p[0]);
                        fold_const(&node->v.p[1]);
                        return 0;
                case en_b_ref:  case en_w_ref:
                case en_l_ref:  case en_compl:
                case en_not:
                        fold_const(&node->v.p[0]);
                        return 0;
                }
#endif
        return 0;
}

void fold_const(node)
/*
 *      reorganize an expression for optimal constant grouping.
 */
struct enode    **node;
{
#if 0
  struct enode    *ep;
        int             i;
        ep = *node;
        if( ep == 0 )
                return;
        if( ep->nodetype == en_add )
                {
                if( ep->v.p[0]->nodetype == en_icon )
                        {
                        ep->v.p[0]->v.i += xfold(ep->v.p[1]);
                        return;
                        }
                else if( ep->v.p[1]->nodetype == en_icon )
                        {
                        ep->v.p[1]->v.i += xfold(ep->v.p[0]);
                        return;
                        }
                }
        else if( ep->nodetype == en_sub )
                {
                if( ep->v.p[0]->nodetype == en_icon )
                        {
                        ep->v.p[0]->v.i -= xfold(ep->v.p[1]);
                        return;
                        }
                else if( ep->v.p[1]->nodetype == en_icon )
                        {
                        ep->v.p[1]->v.i -= xfold(ep->v.p[0]);
                        return;
                        }
                }
        i = xfold(ep);
        if( i != 0 )
                {
                ep = makenode(en_icon,i,0);
                ep = makenode(en_add,ep,*node);
                *node = ep;
                }
#endif
}

void opt4(node)
/*
 *      apply all constant optimizations.
 */
struct enode    **node;
{
#if 0
        opt0(node);
        fold_const(node);
        opt0(node);
#endif
}

// outcode (shorten?)
enum e_gt { nogen, bytegen, wordgen, longgen };
enum e_sg { noseg, codeseg, dataseg };

int	       gentype = nogen;
int	       curseg = noseg;
int        outcol = 0;

/*
struct oplst {
        char    *s;
        int     ov;
        }       opl[] =
        {       {"move",op_move}, {"move",op_moveq}, {"add",op_add},
                {"add",op_addi}, {"add",op_addq}, {"sub",op_sub},
                {"sub",op_subi}, {"sub",op_subq}, {"and",op_and},
                {"or",op_or}, {"eor",op_eor}, {"muls",op_muls},
                {"divs",op_divs}, {"swap",op_swap}, {"beq",op_beq},
                {"bhi",op_bhi}, {"bhs",op_bhs}, {"blo",op_blo},
                {"bls",op_bls}, {"mulu",op_mulu}, {"divu",op_divu},
                {"bne",op_bne}, {"blt",op_blt}, {"ble",op_ble},
                {"bgt",op_bgt}, {"bge",op_bge}, {"neg",op_neg},
                {"not",op_not}, {"cmp",op_cmp}, {"ext",op_ext},
                {"jmp",op_jmp}, {"jsr",op_jsr}, {"rts",op_rts},
                {"lea",op_lea}, {"asr",op_asr}, {"asl",op_asl},
                {"clr",op_clr}, {"link",op_link}, {"unlk",op_unlk},
                {"bra",op_bra}, {"movem",op_movem}, {"pea",op_pea},
                {"cmp",op_cmpi}, {"tst",op_tst}, {"dc",op_dc},
                {0,0} };
*/

void putop(op)
int     op;
{
#if 0
      int     i;
        i = 0;
        while( opl[i].s )
                {
                if( opl[i].ov == op )
                        {
                        // fprintf(output,"\t%s",opl[i].s);
                        return;
                        }
                ++i;
                }
        // printf("DIAG - illegal opcode.\n");
#endif
}

void putconst(offset)
/*
 *      put a constant to the output file.
 */
struct enode    *offset;
{
#if 0
  switch( offset->nodetype )
                {
                case en_autocon:
                case en_icon:
                        // fprintf(output,"%d",offset->v.i);
                        break;
                case en_labcon:
                        // fprintf(output,"L%d",offset->v.i);
                        break;
                case en_nacon:
                        // fprintf(output,"%s",offset->v.p[0]);
                        break;
                case en_add:
                        putconst(offset->v.p[0]);
                        // fprintf(output,"+");
                        putconst(offset->v.p[1]);
                        break;
                case en_sub:
                        putconst(offset->v.p[0]);
                        // fprintf(output,"-");
                        putconst(offset->v.p[1]);
                        break;
                case en_uminus:
                        // fprintf(output,"-");
                        putconst(offset->v.p[0]);
                        break;
                default:
                        // printf("DIAG - illegal constant node.\n");
                        break;
                }
#endif
}

void putlen(l)
/*
 *      append the length field to an instruction.
 */
int     l;
{
#if 0
  switch( l )
                {
                case 0:
                        break;  /* no length field */
                case 1:
                        // fprintf(output,".b");
                        break;
                case 2:
                        // fprintf(output,".w");
                        break;
                case 4:
                        // fprintf(output,".l");
                        break;
                default:
                        // printf("DIAG - illegal length field.\n");
                        break;
                }
#endif
}

void putamode(ap)
/*
 *      output a general addressing mode.
 */
struct amode    *ap;
{
#if 0
  switch( ap->mode )
                {
                case am_immed:
                        // fprintf(output,"#");
                case am_direct:
                        putconst(ap->offset);
                        break;
                case am_areg:
                        // fprintf(output,"a%d",ap->preg);
                        break;
                case am_dreg:
                        // fprintf(output,"d%d",ap->preg);
                        break;
                case am_ind:
                        // fprintf(output,"(a%d)",ap->preg);
                        break;
                case am_ainc:
                        // fprintf(output,"(a%d)+",ap->preg);
                        break;
                case am_adec:
                        // fprintf(output,"-(a%d)",ap->preg);
                        break;
                case am_indx:
                        putconst(ap->offset);
                        // fprintf(output,"(a%d)",ap->preg);
                        break;
                case am_xpc:
                        putconst(ap->offset);
                        // fprintf(output,"(d%d,pc)",ap->preg);
                        break;
                case am_indx2:
                        putconst(ap->offset);
                        // fprintf(output,"(a%d,d%d.l)",ap->preg,ap->sreg);
                        break;
                case am_indx3:
                        putconst(ap->offset);
                        // fprintf(output,"(a%d,a%d.l)",ap->preg,ap->sreg);
                        break;
                case am_mask:
                        put_mask(ap->offset);
                        break;
                default:
                        // printf("DIAG - illegal address mode.\n");
                        break;
                }
#endif
}

void put_code(op,len,aps,apd)
/*
 *      output a generic instruction.
 */
struct amode    *aps, *apd;
int             op, len;
{
#if 0
       if( op == op_dc )
		{
		switch( len )
			{
                        case 1: // fprintf(output,"\tdc.b"); break;
                        case 2: // fprintf(output,"\tdc.w"); break;
                        case 4: // fprintf(output,"\tdc.l"); break;
			}
		}
	else
		{
		putop(op);
        	putlen(len);
		}
        if( aps != 0 )
                {
                // fprintf(output,"\t");
		if( op == op_cmp || op == op_cmpi )
			putamode( apd );
		else
			putamode(aps);
                if( apd != 0 )
                        {
                        // fprintf(output,",");
			if( op == op_cmp || op == op_cmpi )
				putamode( aps );
			else
                        	putamode(apd);
                        }
                }
        // fprintf(output,"\n");
#endif
}

void put_mask(mask)
/*
 *      generate a register mask for restore and save.
 */
int     mask;
{
#if 0
  int     i;
        // fprintf(output,"#$%04x",mask);
#endif
}

void putreg(r)
/*
 *      generate a register name from a tempref number.
 */
int     r;
{
#if 0
   if( r < 8 )
                // fprintf(output,"D%d",r);
        else
                // fprintf(output,"A%d",r - 8);
#endif
}

void gen_strlab(char *s)
/*
 *      generate a named label.
 */
{
#if 0
  // fprintf(output,"%s:\n",s);
#endif
}

void put_label(int lab)
/*
 *      output a compiler generated label.
 */
{
#if 0
  // fprintf(output,"L%d:\n",lab);
#endif
}

void genbyte(int val)
{
#if 0
  if( gentype == bytegen && outcol < 60) {
                // fprintf(output,",%d",val & 0x00ff);
                outcol += 4;
                }
        else    {
                nl();
                // fprintf(output,"\tdc.b\t%d",val & 0x00ff);
                gentype = bytegen;
                outcol = 19;
                }
#endif
}

void genword(int val)
{
#if 0
  if( gentype == wordgen && outcol < 58) {
                // fprintf(output,",%d",val & 0x0ffff);
                outcol += 6;
                }
        else    {
                nl();
                // fprintf(output,"\tdc.w\t%d",val & 0x0ffff);
                gentype = wordgen;
                outcol = 21;
                }
#endif
}

void genlong(int val)
{
#if 0
  if( gentype == longgen && outcol < 56) {
                // fprintf(output,",%d",val);
                outcol += 10;
                }
        else    {
                nl();
                // fprintf(output,"\tdc.l\t%d",val);
                gentype = longgen;
                outcol = 25;
                }
#endif
}

void genref(SYM *sp, int offset)
{
#if 0
  char    sign;
        if( offset < 0) {
                sign = '-';
                offset = -offset;
                }
        else
                sign = '+';
        if( gentype == longgen && outcol < 55 - strlen(sp->name)) {
                if( sp->storage_class == sc_static)
                        // fprintf(output,",L%d%c%d",sp->value.i,sign,offset);
                else
                        // fprintf(output,",%s%c%d",sp->name,sign,offset);
                outcol += (11 + strlen(sp->name));
                }
        else    {
                nl();
                if(sp->storage_class == sc_static)
                    // fprintf(output,"\tdc.l\tL%d%c%d",sp->value.i,sign,offset);
                else
                    // fprintf(output,"\tdc.l\t%s%c%d",sp->name,sign,offset);
                outcol = 26 + strlen(sp->name);
                gentype = longgen;
                }
#endif
}

void genstorage(int nbytes)
{
#if 0
  nl();
        // fprintf(output,"\tds.b\t%d\n",nbytes);
#endif
}

void gen_labref(int n)
{
#if 0
  if( gentype == longgen && outcol < 58) {
                // fprintf(output,",L%d",n);
                outcol += 6;
                }
        else    {
                nl();
                // fprintf(output,"\tdc.l\tL%d",n);
                outcol = 22;
                gentype = longgen;
                }
#endif
}

int     stringlit(s)
/*
 *      make s a string literal and return it's label number.
 */
char    *s;
{
        struct slit     *lp;
        ++global_flag;          /* always allocate from global space. */
        lp = (struct slit *) xalloc(sizeof(struct slit));
        lp->label = nextlabel++;
        lp->str = litlate(s);
        lp->next = strtab;
        strtab = lp;
        --global_flag;
        return lp->label;
}

void dumplits()
/*
 *      dump the string literal pool.
 */
{       char            *cp;
        while( strtab != 0) {
                cseg();
                nl();
                put_label(strtab->label);
                cp = strtab->str;
                while(*cp)
                        genbyte(*cp++);
                genbyte(0);
                strtab = strtab->next;
                }
        nl();
}

void nl()
{
#if 0
 if(outcol > 0) {
                // fprintf(output,"\n");
                outcol = 0;
                gentype = nogen;
                }
#endif
}

void cseg()
{
       if( curseg != codeseg) {
                nl();
                // fprintf(output,"\ttext\n");
                curseg = codeseg;
                }
}

void dseg()
{
  if( curseg != dataseg) {
                nl();
                // fprintf(output,"\tdata\t2\n");
                curseg = dataseg;
                }
}

// peepgen
struct ocode    *peep_head = 0,
                *peep_tail = 0;

struct amode    *copy_addr(ap)
/*
 *      copy an address mode structure (these things dont last).
 */
struct amode    *ap;
{       struct amode    *newap;
        if( ap == 0 )
                return 0;
        newap = (struct amode *) xalloc(sizeof(struct amode));
        newap->mode = ap->mode;
        newap->preg = ap->preg;
        newap->sreg = ap->sreg;
        newap->tempflag = ap->tempflag;
        newap->deep = ap->deep;
        newap->offset = ap->offset;
        return newap;
}

void gen_code(int op,int len,struct amode *ap1, struct amode *ap2)
/*
 *      generate a code sequence into the peep list.
 */
{
#if 0
struct ocode    *new;
        new = xalloc(sizeof(struct ocode));
        new->opcode = op;
        new->length = len;
        new->oper1 = copy_addr(ap1);
        new->oper2 = copy_addr(ap2);
        add_peep(new);
#endif
}

void add_peep(new)
/*
 *      add the ocoderuction pointed to by new to the peep list.
 */
struct ocode    *new;
{       if( peep_head == 0 )
                {
                peep_head = peep_tail = new;
                new->fwd = 0;
                new->back = 0;
                }
        else
                {
                new->fwd = 0;
                new->back = peep_tail;
                peep_tail->fwd = new;
                peep_tail = new;
                }
}

void gen_label(int labno)
/*
 *      add a compiler generated label to the peep list.
 */
{       struct ocode    *new;
        new = (struct ocode *) xalloc(sizeof(struct ocode));
        new->opcode = op_label;
        new->oper1 = (struct amode *) (long) labno;
        add_peep(new);
}

void flush_peep()
/*
 *      output all code and labels in the peep list.
 */
{       opt3();         /* do the peephole optimizations */
        while( peep_head != 0 )
                {
                if( peep_head->opcode == op_label )
                        put_label((int) (long) peep_head->oper1);
                else
                        put_ocode(peep_head);
                peep_head = peep_head->fwd;
                }
}

void put_ocode(struct ocode *p)
/*
 *      output the instruction passed.
 */
{       put_code(p->opcode,p->length,p->oper1,p->oper2);
}

void peep_move(ip)
/*
 *      peephole optimization for move instructions.
 *      makes quick immediates when possible.
 *      changes move #0,d to clr d.
 *      changes long moves to address registers to short when
 *              possible.
 *      changes move immediate to stack to pea.
 */
struct ocode	*ip;
{       struct enode    *ep;
        if( ip->oper1->mode != am_immed )
                return;
        ep = ip->oper1->offset;
        if( ep->nodetype != en_icon )
                return;
        if( ip->oper2->mode == am_areg )
                {
                if( -32768 <= ep->v.i && ep->v.i <= 32768 )
                        ip->length = 2;
                }
        else if( ip->oper2->mode == am_dreg )
                {
                if( -128 <= ep->v.i && ep->v.i <= 127 )
                        {
                        ip->opcode = op_moveq;
                        ip->length = 0;
                        }
                }
        else
                {
                if( ep->v.i == 0 )
                        {
                        ip->opcode = op_clr;
                        ip->oper1 = ip->oper2;
                        ip->oper2 = 0;
                        }
                else if( ip->oper2->mode == am_adec && ip->oper2->preg == 7 )
                        {
                        ip->opcode = op_pea;
                        ip->length = 0;
                        ip->oper1->mode = am_direct;
                        ip->oper2 = 0;
                        }
                }
}

int     equal_address(ap1,ap2)
/*
 *      compare two address nodes and return true if they are
 *      equivalent.
 */
struct amode    *ap1, *ap2;
{       if( ap1 == 0 || ap2 == 0 )
                return 0;
        if( ap1->mode != ap2->mode )
                return 0;
        switch( ap1->mode )
                {
                case am_areg:   case am_dreg:
                case am_ainc:   case am_adec:
                        return ap1->preg == ap2->preg;
                }
        return 0;
}

void peep_add(ip)
/*
 *      peephole optimization for add instructions.
 *      makes quick immediates out of small constants.
 */
struct ocode    *ip;
{       struct enode    *ep;
        if( ip->oper1->mode != am_immed )
                return;
        ep = ip->oper1->offset;
        if( ip->oper2->mode != am_areg )
                ip->opcode = op_addi;
        else
                {
                if( isshort(ep) )
                        ip->length = 2;
                }
        if( ep->nodetype != en_icon )
                return;
        if( 1 <= ep->v.i && ep->v.i <= 8 )
                ip->opcode = op_addq;
        else if( -8 <= ep->v.i && ep->v.i <= -1 )
                {
                ip->opcode = op_subq;
                ep->v.i = -ep->v.i;
                }
}

void peep_sub(ip)
/*
 *      peephole optimization for subtract instructions.
 *      makes quick immediates out of small constants.
 */
struct ocode    *ip;
{       struct enode    *ep;
        if( ip->oper1->mode != am_immed )
                return;
        ep = ip->oper1->offset;
        if( ip->oper2->mode != am_areg )
                ip->opcode = op_subi;
        else
                {
                if( isshort(ep) )
                        ip->length = 2;
                }
        if( ep->nodetype != en_icon )
                return;
        if( 1 <= ep->v.i && ep->v.i <= 8 )
                ip->opcode = op_subq;
        else if( -8 <= ep->v.i && ep->v.i <= -1 )
                {
                ip->opcode = op_addq;
                ep->v.i = -ep->v.i;
                }
}

int     peep_cmp(ip)
/*
 *      peephole optimization for compare instructions.
 *      changes compare #0 to tst and if previous instruction
 *      should have set the condition codes properly delete.
 *      return value is true if instruction was deleted.
 */
struct ocode    *ip;
{       struct ocode    *prev;
        struct enode    *ep;
        if( ip->oper1->mode != am_immed )
                return;
        ep = ip->oper1->offset;
        if( ip->oper2->mode == am_areg )
                {
                if( isshort(ep) )
                        ip->length = 2;
                return;
                }
        ip->opcode = op_cmpi;
        if( ep->nodetype != en_icon || ep->v.i != 0 )
                return;
        ip->oper1 = ip->oper2;
        ip->oper2 = 0;
        ip->opcode = op_tst;
        prev = ip->back;
        if( prev == 0 )
                return;
        if( (((prev->opcode == op_move || prev->opcode == op_moveq) &&
                equal_address(prev->oper1,ip->oper1)) &&
                prev->oper2->mode != am_areg) ||
                (prev->opcode != op_label &&
                equal_address(prev->oper2,ip->oper1)) )
                {
                prev->fwd = ip->fwd;
                if( prev->fwd != 0 )
                        prev->fwd->back = prev;
                }
}

void peep_muldiv(ip,op)
/*
 *      changes multiplies and divides by convienient values
 *      to shift operations. op should be either op_asl or
 *      op_asr (for divide).
 */
struct ocode    *ip;
{       int     shcnt;
        if( ip->oper1->mode != am_immed )
                return;
        if( ip->oper1->offset->nodetype != en_icon )
                return;
        shcnt = ip->oper1->offset->v.i;
/*      vax c doesn't do this type of switch well       */
        if( shcnt == 2) shcnt = 1;
        else if( shcnt == 4) shcnt = 2;
        else if( shcnt == 8) shcnt = 3;
        else if( shcnt == 16) shcnt = 4;
        else if( shcnt == 32) shcnt = 5;
        else if( shcnt == 64) shcnt = 6;
        else if( shcnt == 128) shcnt = 7;
        else if( shcnt == 256) shcnt = 8;
        else if( shcnt == 512) shcnt = 9;
        else if( shcnt == 1024) shcnt = 10;
        else if( shcnt == 2048) shcnt = 11;
        else if( shcnt == 4096) shcnt = 12;
        else if( shcnt == 8192) shcnt = 13;
        else if( shcnt == 16384) shcnt = 14;
        else return;
        ip->oper1->offset->v.i = shcnt;
        ip->opcode = op;
        ip->length = 4;
}

void peep_uctran(ip)
/*
 *      peephole optimization for unconditional transfers.
 *      deletes instructions which have no path.
 *      applies to bra, jmp, and rts instructions.
 */
struct ocode    *ip;
{       while( ip->fwd != 0 && ip->fwd->opcode != op_label )
                {
                ip->fwd = ip->fwd->fwd;
                if( ip->fwd != 0 )
                        ip->fwd->back = ip;
                }
}

void opt3()
/*
 *      peephole optimizer. This routine calls the instruction
 *      specific optimization routines above for each instruction
 *      in the peep list.
 */
{       struct ocode    *ip;
        ip = peep_head;
        while( ip != 0 )
                {
                switch( ip->opcode )
                        {
                        case op_move:
                                peep_move(ip);
                                break;
                        case op_add:
                                peep_add(ip);
                                break;
                        case op_sub:
                                peep_sub(ip);
                                break;
                        case op_cmp:
                                peep_cmp(ip);
                                break;
                        case op_muls:
                                peep_muldiv(ip,op_asl);
                                break;
                        case op_bra:
                        case op_jmp:
                        case op_rts:
                                peep_uctran(ip);
                        }
                ip = ip->fwd;
                }
}


int preprocess()
{       ++lptr;
        lastch = ' ';
        getsym();               /* get first word on line */
        if( lastst != id ) {
                error(ERR_PREPROC);
                return getline(incldepth == 0);
                }
        if( strcmp(lastid,"include") == 0 )
                return doinclude();
        else if( strcmp(lastid,"define") == 0 )
                return dodefine();
        else    {
                error(ERR_PREPROC);
                return getline(incldepth == 0);
                }
}

int doinclude()
{       int     rv;
        getsym();               /* get file to include */
        if( lastst != sconst ) {
                error(ERR_INCLFILE);
                return getline(incldepth == 0);
                }
        inclline[incldepth] = lineno;
        inclfile[incldepth++] = input;  /* push current input file */
        input = fopen(laststr,"r");
        if( input == 0 ) {
                input = inclfile[--incldepth];
                error(ERR_CANTOPEN);
                rv = getline(incldepth == 0);
                }
        else    {
                rv = getline(incldepth == 1);
                lineno = -32768;        /* dont list include files */
                }
        return rv;
}

int dodefine()
{       SYM     *sp;
        getsym();               /* get past #define */
        if( lastst != id ) {
                error(ERR_DEFINE);
                return getline(incldepth == 0);
                }
        ++global_flag;          /* always do #define as globals */
        sp = (SYM *) xalloc(sizeof(SYM));
        sp->name = litlate(lastid);
        sp->value.s = litlate(lptr);
        insert(sp,&defsyms);
        --global_flag;
        return getline(incldepth == 0);
}

void gen_push(reg,rmode)
/*
 *      this routine generates code to push a register onto the stack
 */
int     reg, rmode;
{       struct amode    *ap1;
        ap1 = (struct amode *) xalloc(sizeof(struct amode));
        ap1->preg = reg;
        ap1->mode = rmode;
        gen_code(op_move,4,ap1,push);
}

void gen_pop(reg,rmode)
/*
 *      generate code to pop the primary register in ap from the
 *      stack.
 */
int     reg, rmode;
{       struct amode    *ap1;
        ap1 = (struct amode *) xalloc(sizeof(struct amode));
        ap1->preg = reg;
        ap1->mode = rmode;
        gen_code(op_move,4,pop,ap1);
}

void initstack()
/*
 *      this routine should be called before each expression is
 *      evaluated to make sure the stack is balanced and all of
 *      the registers are marked free.
 */
{       next_data = 0;
        next_addr = 0;
        max_data = 2;
        max_addr = 1;
}

void validate (struct amode *ap)
/*
 *      validate will make sure that if a register within an address
 *      mode has been pushed onto the stack that it is popped back
 *      at this time.
 */
{       switch( ap->mode )
                {
                case am_direct:
                case am_immed:
                        return;         /* no registers used */
                case am_dreg:
                        if( ap->preg > 2 )
                                return; /* not a temporary */
                        if( max_data - ap->deep >= 3 )
                                {
                                gen_pop(ap->preg,am_dreg);
                                --max_data;
                                }
                        break;
                default:
                        if( ap->preg > 1 )
                                return; /* not a temp register */
                        if( max_addr - ap->deep >= 2 )
                                {
                                gen_pop(ap->preg,am_areg);
                                --max_addr;
                                }
                        break;
                }
}

struct amode    *temp_data()
/*
 *      allocate a temporary data register and return it's
 *      addressing mode.
 */
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_dreg;
        ap->preg = next_data % 3;
        ap->deep = next_data;
        if( next_data > max_data )
                {
                gen_push(next_data % 3,am_dreg);
                max_data = next_data;
                }
        ++next_data;
        return ap;
}

struct amode    *temp_addr()
/*
 *      allocate a temporary address register and return it's
 *      addressing mode.
 */
{       struct amode    *ap;
        ap = (struct amode *) xalloc(sizeof(struct amode));
        ap->mode = am_areg;
        ap->preg = next_addr % 2;
        ap->deep = next_addr;
        if( next_addr > max_addr )
                {
                gen_push(next_addr % 2,am_areg);
                max_addr = next_addr;
                }
        ++next_addr;
        return ap;
}

void freeop(struct amode *ap)
/*
 *      release any temporary registers used in an addressing mode.
 */
{       if( ap->mode == am_immed || ap->mode == am_direct )
                return;         /* no registers used */
        if( ap->mode == am_dreg && ap->preg < 3 )
                --next_data;
        else if( ap->preg < 2 )
                --next_addr;
}

struct kwblk {
        char            *word;
        int		      stype;
        }       keywords[] = {
 
        {"int", kw_int}, {"char", kw_char}, {"long", kw_long},
        {"float", kw_float}, {"double", kw_double}, {"return", kw_return},
        {"struct", kw_struct}, {"union", kw_union}, {"typedef", kw_typedef},
        {"enum", kw_enum}, {"static", kw_static}, {"auto", kw_auto},
        {"sizeof", kw_sizeof}, {"do", kw_do}, {"if", kw_if},
        {"else", kw_else}, {"for", kw_for},{"switch", kw_switch},
        {"while", kw_while},{"short", kw_short}, {"extern", kw_extern},
        {"case", kw_case}, {"goto", kw_goto}, {"default", kw_default},
        {"register", kw_register}, {"unsigned", kw_unsigned},
        {"break", kw_break}, {"continue", kw_continue}, {"void", kw_void},
        {0, 0} };
 
int searchkw()
{       struct kwblk    *kwbp;
        kwbp = keywords;
        while(kwbp->word != 0) {
                if(strcmp(lastid,kwbp->word) == 0)
                        return lastst = kwbp->stype;
                else
                        ++kwbp;
                }
        return 0;
}


struct snode    *statement();   /* forward declaration */ 
  
struct snode    *whilestmt() 
/* 
 *      whilestmt parses the c while statement. 
 */ 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode));
        snp->stype = st_while; 
        getsym(); 
        if( lastst != openpa ) 
                error(ERR_EXPREXPECT); 
        else    { 
                getsym(); 
                if( expression(&(snp->exp)) == 0 ) 
                        error(ERR_EXPREXPECT); 
                needpunc( closepa ); 
                snp->s1 = statement(); 
                } 
        return snp; 
} 
  
struct snode    *dostmt() 
/* 
 *      dostmt parses the c do-while construct. 
 */ 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode));
        snp->stype = st_do; 
        getsym(); 
        snp->s1 = statement(); 
        if( lastst != kw_while ) 
                error(ERR_WHILEXPECT); 
        else    { 
                getsym(); 
                if( lastst != openpa ) 
                        error(ERR_EXPREXPECT); 
                else    { 
                        getsym(); 
                        if( expression(&(snp->exp)) == 0 ) 
                                error(ERR_EXPREXPECT); 
                        needpunc(closepa); 
                        } 
                if( lastst != end )
                        needpunc( semicolon );
                } 
        return snp; 
} 
  
struct snode    *forstmt() 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        getsym(); 
        needpunc(openpa); 
        if( expression((struct enode **) &(snp->label)) == 0 )
                snp->label = 0; 
        needpunc(semicolon); 
        snp->stype = st_for; 
        if( expression(&(snp->exp)) == 0 ) 
                snp->exp = 0; 
        needpunc(semicolon); 
        if( expression((struct enode **) &(snp->s2)) == 0 )
                snp->s2 = 0; 
        needpunc(closepa); 
        snp->s1 = statement(); 
        return snp; 
} 
  
struct snode    *ifstmt() 
/* 
 *      ifstmt parses the c if statement and an else clause if 
 *      one is present. 
 */ 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_if; 
        getsym(); 
        if( lastst != openpa ) 
                error(ERR_EXPREXPECT); 
        else    { 
                getsym(); 
                if( expression(&(snp->exp)) == 0 ) 
                        error(ERR_EXPREXPECT); 
                needpunc( closepa ); 
                snp->s1 = statement(); 
                if( lastst == kw_else ) { 
                        getsym(); 
                        snp->s2 = statement(); 
                        } 
                else 
                        snp->s2 = 0; 
                } 
        return snp; 
} 
  
struct snode    *casestmt() 
/* 
 *      cases are returned as seperate statements. for normal 
 *      cases label is the case value and s2 is zero. for the 
 *      default case s2 is nonzero. 
 */ 
{       struct snode    *snp; 
        struct snode    *head, *tail; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        if( lastst == kw_case ) { 
                getsym(); 
                snp->s2 = 0;
                snp->stype = st_case;
                snp->label = intexpr(); 
                } 
        else if( lastst == kw_default) { 
                getsym(); 
                snp->s2 = (struct snode *) 1;
                } 
        else    { 
                error(ERR_NOCASE); 
                return 0; 
                } 
        needpunc(colon); 
        head = 0; 
        while( lastst != end && 
                lastst != kw_case && 
                lastst != kw_default ) { 
                if( head == 0 ) 
                        head = tail = statement(); 
                else    { 
                        tail->next = statement(); 
                        if( tail->next != 0 ) 
                                tail = tail->next; 
                        } 
                tail->next = 0; 
                } 
        snp->s1 = head; 
        return snp; 
} 
  
int     checkcases(head) 
/* 
 *      checkcases will check to see if any duplicate cases 
 *      exist in the case list pointed to by head. 
 */ 
struct snode    *head; 
{     
	struct snode	*top, *cur;
	cur = top = head;
	while( top != 0 )
	{
		cur = top->next;
		while( cur != 0 )
		{
			if( (!(cur->s1 || cur->s2) && cur->label == top->label)
				|| (cur->s2 && top->s2) )
			{
                                // printf(" duplicate case label %d\n",cur->label);
				return 1;
			}
			cur = cur->next;
		}
		top = top->next;
	}
	return 0;
} 
  
struct snode    *switchstmt() 
{       struct snode    *snp; 
        struct snode    *head, *tail; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_switch; 
        getsym(); 
        needpunc(openpa); 
        if( expression(&(snp->exp)) == 0 ) 
                error(ERR_EXPREXPECT); 
        needpunc(closepa); 
        needpunc(begin); 
        head = 0; 
        while( lastst != end ) { 
                if( head == 0 ) 
                        head = tail = casestmt(); 
                else    { 
                        tail->next = casestmt(); 
                        if( tail->next != 0 ) 
                                tail = tail->next; 
                        } 
                tail->next = 0; 
                } 
        snp->s1 = head; 
        getsym(); 
        if( checkcases(head) ) 
                error(ERR_DUPCASE); 
        return snp; 
} 
  
struct snode    *retstmt() 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_return; 
        getsym(); 
        expression(&(snp->exp));
        if( lastst != end )
                needpunc( semicolon );
        return snp; 
} 
  
struct snode    *breakstmt() 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_break; 
        getsym(); 
        if( lastst != end )
                needpunc( semicolon );
        return snp; 
} 
  
struct snode    *contstmt() 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_continue; 
        getsym();
        if( lastst != end )
                needpunc( semicolon );
        return snp;
} 
  
struct snode    *exprstmt() 
/* 
 *      exprstmt is called whenever a statement does not begin 
 *      with a keyword. the statement should be an expression. 
 */ 
{       struct snode    *snp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_expr; 
        if( expression(&(snp->exp)) == 0 ) { 
                error(ERR_EXPREXPECT); 
                getsym(); 
                } 
        if( lastst != end )
                needpunc( semicolon );
        return snp; 
} 
  
struct snode    *compound() 
/* 
 *      compound processes a block of statements and forms a linked 
 *      list of the statements within the block. 
 * 
 *      compound expects the input pointer to already be past the 
 *      begin symbol of the block. 
 */ 
{       struct snode    *head, *tail; 
        head = 0; 
        while( lastst != end ) { 
                if( head == 0 ) 
                        head = tail = statement(); 
                else    { 
                        tail->next = statement(); 
                        if( tail->next != 0 ) 
                                tail = tail->next; 
                        } 
                } 
        getsym(); 
        return head; 
} 
  
struct snode    *labelstmt() 
/* 
 *      labelstmt processes a label that appears before a 
 *      statement as a seperate statement. 
 */ 
{       struct snode    *snp; 
        SYM             *sp; 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        snp->stype = st_label; 
        if( (sp = search(lastid,lsyms.head)) == 0 ) { 
                sp = (SYM *) xalloc(sizeof(SYM));
                sp->name = litlate(lastid); 
                sp->storage_class = sc_label; 
                sp->tp = 0; 
                sp->value.i = nextlabel++; 
                insert(sp,&lsyms); 
                } 
        else    { 
                if( sp->storage_class != sc_ulabel ) 
                        error(ERR_LABEL); 
                else 
                        sp->storage_class = sc_label; 
                } 
        getsym();       /* get past id */ 
        needpunc(colon); 
        if( sp->storage_class == sc_label ) { 
                snp->label = sp->value.i; 
                snp->next = 0; 
                return snp; 
                } 
        return 0; 
} 
  
struct snode    *gotostmt() 
/* 
 *      gotostmt processes the goto statement and puts undefined 
 *      labels into the symbol table. 
 */ 
{       struct snode    *snp; 
        SYM             *sp; 
        getsym(); 
        if( lastst != id ) { 
                error(ERR_IDEXPECT); 
                return 0; 
                } 
        snp = (struct snode *) xalloc(sizeof(struct snode)); 
        if( (sp = search(lastid,lsyms.head)) == 0 ) { 
                sp = (SYM *) xalloc(sizeof(SYM));
                sp->name = litlate(lastid); 
                sp->value.i = nextlabel++; 
                sp->storage_class = sc_ulabel; 
                sp->tp = 0; 
                insert(sp,&lsyms); 
                } 
        getsym();       /* get past label name */ 
        if( lastst != end )
                needpunc( semicolon );
        if( sp->storage_class != sc_label && sp->storage_class != sc_ulabel) 
                error( ERR_LABEL ); 
        else    { 
                snp->stype = st_goto; 
                snp->label = sp->value.i; 
                snp->next = 0; 
                return snp; 
                } 
        return 0; 
} 
  
struct snode    *statement() 
/* 
 *      statement figures out which of the statement processors 
 *      should be called and transfers control to the proper 
 *      routine. 
 */ 
{       struct snode    *snp; 
        switch( lastst ) { 
                case semicolon: 
                        getsym(); 
                        snp = 0; 
                        break; 
                case begin: 
                        getsym(); 
                        snp = compound(); 
                        return snp; 
                case kw_if: 
                        snp = ifstmt(); 
                        break; 
                case kw_while: 
                        snp = whilestmt(); 
                        break; 
                case kw_for: 
                        snp = forstmt(); 
                        break; 
                case kw_return: 
                        snp = retstmt(); 
                        break; 
                case kw_break: 
                        snp = breakstmt(); 
                        break; 
                case kw_goto: 
                        snp = gotostmt(); 
                        break; 
                case kw_continue: 
                        snp = contstmt(); 
                        break; 
                case kw_do: 
                        snp = dostmt(); 
                        break; 
                case kw_switch: 
                        snp = switchstmt(); 
                        break; 
                case id: 
                        while( isspace(lastch) ) 
                                getch(); 
                        if( lastch == ':' ) 
                                return labelstmt(); 
                        /* else fall through to process expression */ 
                default: 
                        snp = exprstmt(); 
                        break; 
                } 
        if( snp != 0 ) 
                snp->next = 0; 
        return snp; 
} 

SYM     *search(char *na,SYM *thead)
{       while( thead != 0) {
                if(strcmp(thead->name,na) == 0)
                        return thead;
                thead = thead->next;
                }
        return 0;
}

SYM     *gsearch(char *na)
{       SYM     *sp;
        if( (sp = search(na,lsyms.head)) == 0)
                sp = search(na,gsyms.head);
        return sp;
}

void insert(SYM *sp, TABLE *table)
{
       if (search(sp->name, table->head) == 0) {
                if( table->head == 0)
                        table->head = table->tail = sp;
                else    {
                        table->tail->next = sp;
                        table->tail = sp;
                        }
                sp->next = 0;
                }
        else
                error(ERR_DUPSYM);
}


int equalnode(struct enode *node1, struct enode *node2)
/*
 *      equalnode will return 1 if the expressions pointed to by
 *      node1 and node2 are equivalent.
 */
{       if( node1 == 0 || node2 == 0 )
                return 0;
        if( node1->nodetype != node2->nodetype )
                return 0;
        if( (node1->nodetype == en_icon || node1->nodetype == en_labcon ||
            node1->nodetype == en_nacon || node1->nodetype == en_autocon) &&
            node1->v.i == node2->v.i )
                return 1;
        if( lvalue(node1) && equalnode(node1->v.p[0], node2->v.p[0]) )
                return 1;
        return 0;
}

struct cse      *searchnode(node)
/*
 *      searchnode will search the common expression table for an entry
 *      that matches the node passed and return a pointer to it.
 */
struct enode    *node;
{       struct cse      *csp;
        csp = olist;
        while( csp != 0 ) {
                if( equalnode(node,csp->exp) )
                        return csp;
                csp = csp->next;
                }
        return 0;
}

struct enode    *copynode(struct enode *node)
/*
 *      copy the node passed into a new enode so it wont get
 *      corrupted during substitution.
 */
{       struct enode    *temp;
        if( node == 0 )
                return 0;
        temp = (struct enode *) xalloc(sizeof(struct enode));
        temp->nodetype = node->nodetype;
        temp->v.p[0] = node->v.p[0];
        temp->v.p[1] = node->v.p[1];
        return temp;
}

struct cse *enternode(struct enode *node, int duse)
/*
 *      enternode will enter a reference to an expression node into the
 *      common expression table. duse is a flag indicating whether or not
 *      this reference will be dereferenced.
 */
{       struct cse      *csp;
        if( (csp = searchnode(node)) == 0 ) {   /* add to tree */
                csp = (struct cse *) xalloc(sizeof(struct cse));
                csp->next = olist;
                csp->uses = 1;
                csp->duses = (duse != 0);
                csp->exp = copynode(node);
                csp->voidf = 0;
                olist = csp;
                return csp;
                }
        ++(csp->uses);
        if( duse )
                ++(csp->duses);
        return csp;
}

struct cse      *voidauto(node)
/*
 *      voidauto will void an auto dereference node which points to
 *      the same auto constant as node.
 */
struct enode    *node;
{       struct cse      *csp;
        csp = olist;
        while( csp != 0 ) {
                if( lvalue(csp->exp) && equalnode(node,csp->exp->v.p[0]) ) {
                        if( csp->voidf )
                                return 0;
                        csp->voidf = 1;
                        return csp;
                        }
                csp = csp->next;
                }
        return 0;
}

void scanexpr(node,duse)
/*
 *      scanexpr will scan the expression pointed to by node for optimizable
 *      subexpressions. when an optimizable expression is found it is entered
 *      into the tree. if a reference to an autocon node is scanned the
 *      corresponding auto dereferenced node will be voided. duse should be
 *      set if the expression will be dereferenced.
 */
struct enode    *node;
{
#if 0
    struct cse      *csp, *csp1;
        int             n;
        if( node == 0 )
                return;
        switch( node->nodetype ) {
                case en_icon:
                case en_labcon:
                case en_nacon:
                        enternode(node,duse);
                        break;
                case en_autocon:
                        if( (csp = voidauto(node)) != 0 ) {
                                csp1 = enternode(node,duse);
                                csp1->uses = (csp1->duses += csp->uses);
                                }
                        else
                                enternode(node,duse);
                        break;
                case en_b_ref:
                case en_w_ref:
                case en_l_ref:
                        if( node->v.p[0]->nodetype == en_autocon ) {
                                csp = enternode(node,duse);
                                if( csp->voidf )
                                        scanexpr(node->v.p[0],1);
                                }
                        else
                                scanexpr(node->v.p[0],1);
                        break;
                case en_cbl:    case en_cwl:
                case en_cbw:    case en_uminus:
                case en_compl:  case en_ainc:
                case en_adec:   case en_not:
                        scanexpr(node->v.p[0],duse);
                        break;
                case en_asadd:  case en_assub:
                case en_add:    case en_sub:
                        scanexpr(node->v.p[0],duse);
                        scanexpr(node->v.p[1],duse);
                        break;
                case en_mul:    case en_div:
                case en_lsh:    case en_rsh:
                case en_mod:    case en_and:
                case en_or:     case en_xor:
                case en_lor:    case en_land:
                case en_eq:     case en_ne:
                case en_gt:     case en_ge:
                case en_lt:     case en_le:
                case en_asmul:  case en_asdiv:
                case en_asmod:  case en_aslsh:
                case en_asrsh:  case en_asand:
                case en_asor:   case en_cond:
                case en_void:   case en_assign:
                        scanexpr(node->v.p[0],0);
                        scanexpr(node->v.p[1],0);
                        break;
                case en_fcall:
                        scanexpr(node->v.p[0],1);
                        scanexpr(node->v.p[1],0);
                        break;
                }
#endif
}

void scan(block)
/*
 *      scan will gather all optimizable expressions into the expression
 *      list for a block of statements.
 */
struct snode    *block;
{
#if 0
      while( block != 0 ) {
                switch( block->stype ) {
                        case st_return:
                        case st_expr:
                                opt4(&block->exp);
                                scanexpr(block->exp,0);
                                break;
                        case st_while:
                        case st_do:
                                opt4(&block->exp);
                                scanexpr(block->exp,0);
                                scan(block->s1);
                                break;
                        case st_for:
                                opt4(&block->label);
                                scanexpr(block->label,0);
                                opt4(&block->exp);
                                scanexpr(block->exp,0);
                                scan(block->s1);
                                opt4(&block->s2);
                                scanexpr(block->s2,0);
                                break;
                        case st_if:
                                opt4(&block->exp);
                                scanexpr(block->exp,0);
                                scan(block->s1);
                                scan(block->s2);
                                break;
                        case st_switch:
                                opt4(&block->exp);
                                scanexpr(block->exp,0);
                                scan(block->s1);
                                break;
                        case st_case:
                                scan(block->s1);
                                break;
                        }
                block = block->next;
                }
#endif
}

void exchange(c1)
/*
 *      exchange will exchange the order of two expression entries
 *      following c1 in the linked list.
 */
struct cse      **c1;
{       struct cse      *csp1, *csp2;
        csp1 = *c1;
        csp2 = csp1->next;
        csp1->next = csp2->next;
        csp2->next = csp1;
        *c1 = csp2;
}

int     desire(csp)
/*
 *      returns the desirability of optimization for a subexpression.
 */
struct cse      *csp;
{       if( csp->voidf || (csp->exp->nodetype == en_icon &&
                        csp->exp->v.i < 16 && csp->exp->v.i >= 0))
                return 0;
        if( lvalue(csp->exp) )
                return 2 * csp->uses;
        return csp->uses;
}

int     bsort(list)
/*
 *      bsort implements a bubble sort on the expression list.
 */
struct cse      **list;
{       struct cse      *csp1, *csp2;
        int             i;
        csp1 = *list;
        if( csp1 == 0 || csp1->next == 0 )
                return 0;
        i = bsort( &(csp1->next));
        csp2 = csp1->next;
        if( desire(csp1) < desire(csp2) ) {
                exchange(list);
                return 1;
                }
        return 0;
}

void allocate()
/*
 *      allocate will allocate registers for the expressions that have
 *      a high enough desirability.
 */
{       struct cse      *csp;
        struct enode    *exptr;
        int             datareg, addreg, mask, rmask, i;
        struct amode    *ap, *ap2;
        datareg = 3;
        addreg = 10;
        mask = 0;
		rmask = 0;
        while( bsort(&olist) );         /* sort the expression list */
        csp = olist;
        while( csp != 0 ) {
                if( desire(csp) < 3 )
                        csp->reg = -1;
                else if( csp->duses > csp->uses / 4 && addreg < 14 )
                        csp->reg = addreg++;
                else if( datareg < 8 )
                        csp->reg = datareg++;
                else
                        csp->reg = -1;
                if( csp->reg != -1 )
				{
						rmask = rmask | (1 << (15 - csp->reg));
                        mask = mask | (1 << csp->reg);
				}
                csp = csp->next;
                }
        if( mask != 0 )
                gen_code(op_movem,4,make_mask(rmask),push);
        save_mask = mask;
        csp = olist;
        while( csp != 0 ) {
                if( csp->reg != -1 )
                        {               /* see if preload needed */
                        exptr = csp->exp;
                        if( !lvalue(exptr) || (exptr->v.p[0]->v.i > 0) )
                                {
                                initstack();
                                ap = gen_expr(exptr,F_ALL,4);
                                if( csp->reg < 8 )
                                        ap2 = makedreg(csp->reg);
                                else
                                        ap2 = makeareg(csp->reg - 8);
                                gen_code(op_move,4,ap,ap2);
                                freeop(ap);
                                }
                        }
                csp = csp->next;
                }
}

void repexpr(node)
/*
 *      repexpr will replace all allocated references within an expression
 *      with tempref nodes.
 */
struct enode    *node;
{       struct cse      *csp;
        if( node == 0 )
                return;
        switch( node->nodetype ) {
                case en_icon:
                case en_nacon:
                case en_labcon:
                case en_autocon:
                        if( (csp = searchnode(node)) != 0 )
                                if( csp->reg > 0 ) {
                                        node->nodetype = en_tempref;
                                        node->v.i = csp->reg;
                                        }
                        break;
                case en_b_ref:
                case en_w_ref:
                case en_l_ref:
                        if( (csp = searchnode(node)) != 0 ) {
                                if( csp->reg > 0 ) {
                                        node->nodetype = en_tempref;
                                        node->v.i = csp->reg;
                                        }
                                else
                                        repexpr(node->v.p[0]);
                                }
                        else
                                repexpr(node->v.p[0]);
                        break;
                case en_cbl:    case en_cbw:
                case en_cwl:    case en_uminus:
                case en_not:    case en_compl:
                case en_ainc:   case en_adec:
                        repexpr(node->v.p[0]);
                        break;
                case en_add:    case en_sub:
                case en_mul:    case en_div:
                case en_mod:    case en_lsh:
                case en_rsh:    case en_and:
                case en_or:     case en_xor:
                case en_land:   case en_lor:
                case en_eq:     case en_ne:
                case en_lt:     case en_le:
                case en_gt:     case en_ge:
                case en_cond:   case en_void:
                case en_asadd:  case en_assub:
                case en_asmul:  case en_asdiv:
                case en_asor:   case en_asand:
                case en_asmod:  case en_aslsh:
                case en_asrsh:  case en_fcall:
                case en_assign:
                        repexpr(node->v.p[0]);
                        repexpr(node->v.p[1]);
                        break;
                }
}

void repcse(block)
/*
 *      repcse will scan through a block of statements replacing the
 *      optimized expressions with their temporary references.
 */
struct snode    *block;
{       while( block != 0 ) {
                switch( block->stype ) {
                        case st_return:
                        case st_expr:
                                repexpr(block->exp);
                                break;
                        case st_while:
                        case st_do:
                                repexpr(block->exp);
                                repcse(block->s1);
                                break;
                        case st_for:
                                repexpr(block->label);
                                repexpr(block->exp);
                                repcse(block->s1);
                                repexpr(block->s2);
                                break;
                        case st_if:
                                repexpr(block->exp);
                                repcse(block->s1);
                                repcse(block->s2);
                                break;
                        case st_switch:
                                repexpr(block->exp);
                                repcse(block->s1);
                                break;
                        case st_case:
                                repcse(block->s1);
                                break;
                        }
                block = block->next;
                }
}

void opt1(block)
/*
 *      opt1 is the externally callable optimization routine. it will
 *      collect and allocate common subexpressions and substitute the
 *      tempref for all occurrances of the expression within the block.
 *
 *		optimizer is currently turned off...
 */
struct snode    *block;
{
#if 0
		olist = 0;
        scan(block);            /* collect expressions */
        allocate();             /* allocate registers */
        repcse(block);          /* replace allocated expressions */
#endif
}

