

/*
 *  Project     Fargo III
 *  Author      TriX
 *  Description TI92 linker for the parallel & serial cable
 *  Module      interface
 */

#ifndef TI92LINK_INTERFACE
#define TI92LINK_INTERFACE

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Structures */
typedef struct {
   char  TI92Marker[8];
   char  hiversion, loversion;
   char  notused[8];
   char  comment[40];
   short entries;
   long  first_entry;
   char  ROMVersion[8];
   char  backuptype;
   char  notused2[3];
   long  filesize;
   short header_end;           /* 0x5aa5 marker */
} TIBackupHeader;

typedef struct {
   char  TI92Marker[8];
   char  hiversion, loversion;
   char  directory[8];
   char  comment[40];
   short entries;
   long  first_entry;
   char  filename[8];
   char  filetype;
   char  notused[3];
   long  filesize;
   short header_end;           /* 0xa55a marker */
   char  TwoZeros[2];
} TI92VariableHeader;          /* PRGM variables, expressions, ... */

typedef struct {
   char  sender, type;
   short stuff;
} TISendHeader;

#define COM_PORT_1      0x8000
#define COM_PORT_2      0x8001
#define COM_PORT_3      0x8002
#define COM_PORT_4      0x8003
#define LPT_PORT_1      0x0000
#define LPT_PORT_2      0x0001
#define LPT_PORT_3      0x0002
#define LPT_PORT_4      0x0003

FILE *Device;
int  LPT_Port;

typedef struct TIHeader {
   int Type;
   int Stuff;
} TIHeader;

typedef struct VarHeader {
   long VariableSize;
   int  VariableType;
   int  Namelength;
   char VariableName[18];
   int  Checksum;
} VarHeader;

int SetPort (int Port);
int ClosePort ();

int SendHInts (int type, int stuff);
int SendHeader (TIHeader tih);
int GetHeader (TIHeader *tih);

int SendVarHeader (VarHeader vh);
int GetVarHeader (VarHeader *vh);

int SendByte (unsigned char byte);
int GetByte (unsigned char *byte);

int GetChar ();
int GetWord ();
long GetDWord ();

int GetBody (char *savewhere, int *size);

#ifdef __cplusplus
}
#endif


#endif
